// used by PE2LE and PE2ELF
unit descript;

interface

procedure load_module_description(const executable:string);

var
  module_description            :String;

implementation

uses
  Dos;

procedure load_module_description(const executable:string);
  var
    p                           :PathStr;
    n                           :NameStr;
    e                           :ExtStr;
    exe_beschreibung_datei      :text;
    beschreibung_gross          :string;
    i,line_num                  :longint;
  begin
    FSplit(executable,p,n,e);

    (* *.EDS Executabe Description - plain text file for PE2LE *)

    Assign(exe_beschreibung_datei,p+n+'.EDS');
    (*$I-*)
    Reset(exe_beschreibung_datei);
    (*$I+*)

    if IOResult<>0 then
      begin
        Assign(exe_beschreibung_datei,n+'.EDS');
        (*$I-*)
        Reset(exe_beschreibung_datei);
        (*$I+*)
      end;

    if IOResult=0 then
      begin
        ReadLn(exe_beschreibung_datei,module_description);
        Close(exe_beschreibung_datei);
        Exit;
      end;

    (* *.DEF - Linker definition file - description line *)

    Assign(exe_beschreibung_datei,p+n+'.DEF');
    (*$I-*)
    Reset(exe_beschreibung_datei);
    (*$I+*)

    if IOResult<>0 then
      begin
        Assign(exe_beschreibung_datei,n+'.DEF');
        (*$I-*)
        Reset(exe_beschreibung_datei);
        (*$I+*)
      end;

    if IOResult=0 then
      begin
        while not Eof(exe_beschreibung_datei) do
          begin
            ReadLn(exe_beschreibung_datei,module_description);
            beschreibung_gross:=module_description;
            for i:=1 to Length(module_description) do
              beschreibung_gross[i]:=UpCase(beschreibung_gross[i]);
            i:=Pos('DESCRIPTION',beschreibung_gross);
            if i<>0 then
              begin
                Delete(module_description,1,i+Length('DESCRIPTION'));
                while (module_description<>'') and (module_description[1] in [' ',^I]) do
                  Delete(module_description,1,1);
                while (module_description<>'') and (module_description[Length(module_description)] in [' ',^I]) do
                  Delete(module_description,Length(module_description),1);
                if module_description<>'' then
                  if  (module_description[1]=module_description[Length(module_description)])
                  and (module_description[1] in ['"','''']) then
                    module_description:=Copy(module_description,2,Length(module_description)-2);
                Close(exe_beschreibung_datei);
                Exit;
              end;
          end;
        Close(exe_beschreibung_datei);
      end;

    (* *.pas - source code {$D Description} only in the begin of source *)

    Assign(exe_beschreibung_datei,n+'.PAS');
    (*$I-*)
    Reset(exe_beschreibung_datei);
    (*$I+*)

    if IOResult=0 then
      begin
        line_num:=0;
        while (not Eof(exe_beschreibung_datei)) and (line_num<50) do
          begin
            ReadLn(exe_beschreibung_datei,module_description);
            Inc(line_num);
            i:=Pos('$D ',module_description);
            if ((i>1) and (module_description[i-1]='{')) then
              begin
                Delete(module_description,1,i+Length('$D ')-1);
                i:=Pos('}',module_description);
                if i>0 then Delete(module_description,i,255);
              end
            else
            if ((i>2) and (module_description[i-2]='(') and (module_description[i-1]='*')) then
              begin
                Delete(module_description,1,i+Length('$D ')-1);
                i:=Pos('*)',module_description);
                if i>0 then Delete(module_description,i,255);
              end
            else
              Continue;

            while (module_description<>'') and (module_description[1] in [' ',^I]) do
              Delete(module_description,1,1);
            while (module_description<>'') and (module_description[Length(module_description)] in [' ',^I]) do
              Delete(module_description,Length(module_description),1);

            Close(exe_beschreibung_datei);
            Exit;
          end;
        Close(exe_beschreibung_datei);
      end;

    module_description:='';
  end;

end.
