
type
  DWord                 =longint;
  PImageImportDirectory = ^TImageImportDirectory;
  TImageImportDirectory =
    packed record
      Characteristics:       DWord;
      TimeDateStamp:         DWord;
      MajorVersion:          SmallWord;
      MinorVersion:          SmallWord;
      Name_:                 DWord;
      IMPORT_LOOKUP_TABLE:   DWord;
    //IMPORT_ADDRESS_TABLE:  DWord;
    end;

const
  import_schreib_puffer :pByteArray     =nil;
  import_schreib_index  :longint        =0;

procedure idata_umwandlung;

  const
    null                :byte=0;
    eins                :byte=1;

  var
    p                   :pByteArray;
    p_import_dir        :PImageImportDirectory absolute p;
    schreib_puffer      :pByteArray;
    schreib_index       :longint;
    dll_name            :string;
    index_anzahl_importe:longint;
    anzahl_importe      :longint;
    IMPORT_LOOKUP       :^longint;
    IMPORT_LOOKUP_index :longint;
    proz_ord            :longint;
    proz_name           :string;
    gefunden            :boolean;
    z                   :longint;

  procedure schreibe(const b;const anzahl:longint);
    begin
      ReAllocMem(import_schreib_puffer,schreib_index+anzahl);
      Move(b,import_schreib_puffer^[import_schreib_index],anzahl);
      Inc(import_schreib_index,anzahl);
    end;

  begin
    p:=idata_puffer;
    while p_import_dir^.Name_<>0 do
      begin
        (* dll-Name *)
        dll_name:=StrPas(@idata_puffer^[p_import_dir^.Name_-pe_obj_tab[idata].rva]);
        schreibe(dll_name,1+Length(dll_name));

        (* Anzahl Importe *)
        index_anzahl_importe:=import_schreib_index;
        anzahl_importe:=0;
        (* noch unbekannt *)
        schreibe(anzahl_importe,SizeOf(anzahl_importe));

        IMPORT_LOOKUP:=@idata_puffer^[p_import_dir^.IMPORT_LOOKUP_TABLE-pe_obj_tab[idata].rva];
        IMPORT_LOOKUP_index:=p_import_dir^.IMPORT_LOOKUP_TABLE;
        while IMPORT_LOOKUP^<>0 do
          begin
            Inc(anzahl_importe);

            if (IMPORT_LOOKUP^ and $80000000)<>0 then
              begin (* ordinal *)
                proz_name:='';
                schreibe(proz_name,1+Length(proz_name));
                proz_ord:=IMPORT_LOOKUP^ and $7fffffff;
                schreibe(proz_ord,SizeOf(proz_ord));
              end
            else
              begin (* name *)
                proz_name:=StrPas(@idata_puffer^[IMPORT_LOOKUP^-pe_obj_tab[idata].rva+2]);
                schreibe(proz_name,1+Length(proz_name));
              end;

            (* absolute Importe *)
            schreibe(null,SizeOf(null));
            (* relative Importe *)
            schreibe(eins,SizeOf(eins));

            (* suche $ff $25 (Adresse)                     jmp d [Adresse] *)
            gefunden:=false;
            for z:=pe_obj_tab[code32].physical_size-6+1 downto 0 do
              if  (code_puffer^[z]=$ff)
              and (code_puffer^[z+1]=$25)
              and (pLongint(@code_puffer^[z+2])^=pe_kopf.image_base+IMPORT_LOOKUP_index)
               then
                begin
                  import_jmp_min:=Min(import_jmp_min,pe_kopf.image_base+pe_obj_tab[code32].rva+z+0  );
                  import_jmp_max:=Max(import_jmp_max,pe_kopf.image_base+pe_obj_tab[code32].rva+z+6-1);
                  gefunden:=true;
                  (* umwandeln in $e9 (Adresse-(fundstelle+5))   jmp Adresse     *)
                  code_puffer^[z]:=$e9;
                  pLongint(@code_puffer^[z+1])^:=0;
                  code_puffer^[z+5]:=$cc;
                  Break;
                end;

            if not gefunden then
              Abbruch(textz_sprung_zum_import_nicht_gefunden^);

            Inc(z); (* $e9 ... *)
            schreibe(z,SizeOf(z));

            Inc(IMPORT_LOOKUP);
            Inc(IMPORT_LOOKUP_index,4);
          end;

        Meml[Ofs(import_schreib_puffer^[index_anzahl_importe])]:=anzahl_importe;

        (* zur nchsten dll *)
        Inc(p_import_dir);
      end;

    (* Abschlu mit dll '' *)
    dll_name:='';
    schreibe(dll_name,1+Length(dll_name));
  end;

