{$H-,R+,S-,I+}{&Use32+}

program pe_le;

(*$M 5000000*)
(*$D PE to LE EXE converter * Veit Kannegieser *)

uses
  //MemLeaks,
  Dos,                  // FExpand
  WinDos,
  VpSysLow,
  Objects,
  pe2lety,
  VpUtils,
  pe2lespr,
  Crt,
  reskonv,
  Strings,
  Filter,
  Descript;

const
  currentversion='v0.9.0316';
  version='1998.10.22..2004.05.23..(VPT 2009.03.16)';

(*
  Veit Kannegieser * 22.10.1998
  PE -> LE Format Konvertierung fr DPMI32

  Eingabedatei = Virtual Pascal
  Ausgabedatei = Watcom WLINK FORM OS/2 LE

  Vorteile:
  * kein externer Linker (WLINKW.EXE) erforderlich
  * Location-Untersttzung
  * "WATCOM"-Zeichenkette am Anfang ( /F )

  1998.12.29 verbesserte Statistik
  1998.12.30 relo-Kompressor
  1999.01.07 Berechnung Locinfo
  1999.01.12 Hilfe verbessert
  1999.01.14 .RSRC wieder untersttzt
             eine Fixup fr Xpack (XE.EXE 1220)
  1999.01.15 unit memleaks ...
  1999.04.06 /P:3 fr Zusammenarbeit mit VPDDID.SYS
  1999.04.07 /P:3 funktioniert auch mit Resourcen
  1999.04.25 /P:3 funktioniert auch ohne Resourcen,/P:3 in Hilfe aufgenommen
  1999.04.26 Debuginformationen fr VPDBGAPI
  1999.07.04 physical_size->virtual_size (VP 2.00.RC2 erzeugt 512-Byte Gruppen)
  1999.08.16 Anpassung an Aufruf durch VPC.EXE (VP.INI)
             Suche der DOS-Extender in \VP20\BIN.D32\
  1999.09.21 DATA32 wird wie _BSS behandelt
  2000.01.31 start2_variable5 implementiert und in vpsysd32.pas eingefgt
             dadurch wurde fast 4096 Byte EXE-Speicher eingespart
             Umstieg auf Sprache2
             Quelltextverschnerung, Zuweisung von nil nach Dispose
  2000.02.17 Fehlerbehebung: Suche nach startcode_relopack in VPSYSD32.PAS
             wurde nach erstem Fehlschlag abgebrochen
  2000.04.02 Lschen des (nicht initialisierten) Variablenbereiches
             es kam sonst zu Problemen in SysUtils bei huge-Strings
             die schon Werte hatten..
  2000.08.30 Umformung des Import-Bereiches zu eineem Resource-Block
  2000.11.09 CRT-Behandlung bei Umleitung aufheben (VP 2.1.243)
  2002.06.30 Suche nach DOS-Stub mit WinDos,
             Suche nach der Beschreibung in *.EDS, *.DEF und *.PAS
  2002.07.05 Fehlerbehebung Suchergebnis
  2003.08.02 Unicode-Resourcestring,
             String-Resourcenamen
       08.05 uses buffered stream instead of BlockWrite
  2003.12.11 set raw mode for \DEV\VPDDID$$ read
  2004.05.19 fixed 'set raw mode' - deb_link copy
  2004.05.20 do not call FileSearch for empty stub name (bogus can not open file "E:\.")
  2004.05.23 restore ES (PSP) selector in debug entrypoint code
             continue program in debug stub when not loaded in debugging environment

                                                        *)
type
  exeformats=(le,lx);
const
  stub          :pByteArray             =nil;
  stub_laenge   :longint                =0;
  entry_table   :byte                   =0;
  import___     :array[1..3] of byte    =(0,0,0);
  resident_name_term:array[1..3] of byte=(0,0,0); (* dw 0 (ordinal) db 0 (Ende) *)
  beschreibung_term :array[1..3] of byte=(0,0,0);
  stumm         :(ganz_stumm,normal,ausfuerlich)=normal;
  relopack_position:longint             =-1;
  ziel_va       :longint                =0;
  startcodewahl :startcode_typ          =startcode_relopack;

  relo_zaehler  :longint                =0;
  relopacklaenge:longint                =0;
  resource_codepage             :string ='';
  output_format                 :exeformats=le;

var
  relopack_position_gefunden                    :longint;
  pe_name,stub_name,le_name,
  db_name,resource_output                       :string;
  leer                                          :array[0..4096-1] of byte;
  pe_start                                      :longint;
  pe_kopf                                       :pe_kopf_typ;
  pe_obj_tab                                    :array[pe_obj_typen] of pe_obj_typ;
  pe_obj_tab_all                                :array[0..95] of pe_obj_typ;
  code_puffer,
  data_puffer,
  relo_puffer,
  reso_puffer,
  idata_puffer                                  :pByteArray;

  beschreibung                                  :string;

  le_kopf                                       :le_kopf_typ;
  le_obj_1,le_obj_2                             :le_obj_typ;

  page_map_table_entries                   :longint;
  (* LE[$6c]+Fixup_page_table_z[page]->fixup *)
  Fixup_page_table_z                            :Fixup_page_table_z_typ;
  (* Object_Page_Map_Table_feld_z^[page]->daten *)
  Object_Page_Map_Table_feld_z                  :pointer; (* page_map_entry_feld_z_typ *)
  resident_name                                 :string;
  le_relo_puffer                                :pByteArray;
  le_relo_puffer_position                       :longint;

  delta                                         :longint;

  resourcen_vorhanden                           :boolean;
  code_vorhanden, data_vorhanden,
  relo_vorhanden, importe_vorhanden             :boolean;

  relopack_page,relopack_eip                    :longint;

  stacklaenge                                   :longint;

  info_block_tabelle                            :info_block_tabelle_typ;

  le_image                                      :pByteArray;

  eip_pos                                       :longint;
  deb_link_start                                :longint;

  vp21_verzeichnis                              :string;

  le_image_startcode                            :longint;

type
  suchmaske= (* DEB_LINK.PAS *)
    packed record
      kennung1:longint;
      kennung2:longint;
      kennung3:longint;
      opcode:array[1..6] of byte;
      eip:longint;
    end;

(*$I START.PAS*)

function pack24bit(x: longint): rec24bit;
  var
    y: array[0..3]of byte absolute x;
  begin
    result[0]:=y[2];
    result[1]:=y[1];
    result[2]:=y[0]
  end;

function gleich4(var v1; const v2: array of char): boolean;
  var
    x1: longint absolute v1;
    x2: longint absolute v2;
  begin
    gleich4:= x1 = x2;
  end;

procedure Abbruch(const zk:string);
  begin
    WriteLn(zk);

    (* Write(^G^Z); *)
    Halt(255);
  end;


procedure aufrunden(var l:longint;const r:longint);
  begin
    l:=((l+r-1) div r)*r;
  end;

function aufrundenf(const l:longint;const r:longint):longint;
  begin
    aufrundenf:=((l+r-1) div r)*r;
  end;

procedure weggeben_p(var p:pointer);
  begin
    Dispose(p);
    p:=nil;
  end;

const
  last_length:longint=0;

procedure status(const zk:string);
  var
    z,diff:longint;
  begin
    Write(^m);
    Write(zk);
    if last_length>Length(zk) then
      begin
        diff:=last_length-Length(zk);
        for z:=1 to diff do Write(' ');
        for z:=1 to diff do Write(^h);
      end;
    (*$IFDEF DEBUG*)
    {if last_length<>Length(zk) then
      SysCtrlSleep(1000);}
    (*$ENDIF*)
    last_length:=Length(zk);
    if zk<>'' then Write(' ');
  end;

procedure hilfe;
  begin
    status('');
    WriteLn(textz_hilfe1^);
    WriteLn(textz_hilfe2^);
    WriteLn(textz_hilfe3^);
    WriteLn(textz_hilfe4^);
    WriteLn(textz_hilfe5^);
    WriteLn(textz_hilfe6^);
    WriteLn(textz_hilfe7^);
    WriteLn(textz_hilfe7a^);
    WriteLn(textz_hilfe8^);
    WriteLn(textz_hilfe9^);
    WriteLn(textz_hilfe10^);
    WriteLn(textz_hilfe11^);
    WriteLn(textz_hilfe12^);
    WriteLn(textz_hilfe13^);
    WriteLn(textz_hilfe14^);
    WriteLn(textz_hilfe15^);
    Write(^Z);
    Halt(255);
  end;


function pages(const l:longint):longint;
  begin
    pages:=(l+4096-1) div 4096;
  end;

procedure OpenReadBST(var f:pBufStream;const filename:string);
  begin
    f:=New(pBufStream,Init(filename,stOpenRead,512*1024));
    if f^.Status<>stOK then
      Abbruch(textz_can_not_open1^+filename+textz_can_not_open2^);
  end;

procedure CreateBST(var f:pBufStream;const filename:string);
  begin
    f:=New(pBufStream,Init(filename,stCreate,512*1024));
    if f^.Status<>stOK then
      Abbruch(textz_Error_creating1^+filename+textz_Error_creating2^);
  end;

procedure BlockReadBST(f:pBufStream;var buffer;const size:longint);
  begin
    f^.Read(buffer,size);
    if f^.Status<>stOK then
      Abbruch(textz_Source_stream_read_error^);
  end;

procedure BlockWriteBST(f:pBufStream;var buffer;const size:longint);
  begin
    f^.Write(buffer,size);
    if f^.Status<>stOK then
      Abbruch(textz_Target_stream_write_error^);
  end;

procedure SeekBST(f:pBufStream;l:longint);
  begin
    f^.Seek(l);
    if f^.Status<>stOK then
      Abbruch(textz_Stream_seek_error^);
  end;

procedure CloseBST(var f:pBufStream);
  begin
    f^.Done;
    f:=nil;
  end;

function FileSizeBST(f:pBufStream):longint;
  begin
    Result:=f^.GetSize;
    if f^.Status<>stOK then
      Abbruch(textz_Stream_FileSize_error^);
  end;

(*************************************************************************)
procedure lies_stub(const dateiname:string);
  var
    ds                  :pBufStream;
    puffer              :array[0..$3f] of char;
    exe_kopf            :exe_kopf_typ;
    code_laenge         :longint;
    position            :longint;
  begin

    status(textz_Processing_Stub_File^);
    if dateiname='' then
      begin
        stub_laenge:=0;
        Exit;
      end;

    OpenReadBST(ds,dateiname);
    BlockReadBST(ds,exe_kopf,2);

    (* EXE? *)
    if (exe_kopf.sig='MZ')
    or (exe_kopf.sig='ZM')
     then
      begin
        SeekBST(ds,0);
        BlockReadBST(ds,exe_kopf,SizeOf(exe_kopf));

        code_laenge:=exe_kopf.page512*512;
        if exe_kopf.mod512>0 then
          Inc(code_laenge,exe_kopf.mod512-512);
        Dec(code_laenge,longint(exe_kopf.kopfgroesse)*16);

        stub_laenge:=$40+longint(exe_kopf.relo_anz)*4;
        aufrunden(stub_laenge,16);
        Inc(stub_laenge,code_laenge);
        aufrunden(stub_laenge,16);

        GetMem(stub,stub_laenge);
        FillChar(stub^,stub_laenge,0);

        exe_kopf.mod512:=stub_laenge mod 512;
        exe_kopf.page512:=stub_laenge div 512;
        if exe_kopf.mod512>0 then
          Inc(exe_kopf.page512);

        SeekBST(ds,exe_kopf.relo_ofs);
        position:=$40;
        exe_kopf.relo_ofs:=position;
        BlockReadBST(ds,stub^[position],longint(exe_kopf.relo_anz)*4);
        Inc(position,longint(exe_kopf.relo_anz)*4);
        aufrunden(position,16);

        SeekBST(ds,longint(exe_kopf.kopfgroesse)*16);
        exe_kopf.kopfgroesse:=position div 16;
        BlockReadBST(ds,stub^[position],code_laenge);
        exe_kopf.kopfgroesse:=($40+longint(exe_kopf.relo_anz)*4+15) div 16;

        with exe_kopf do
          begin
            pruefsumme:=0;
            ov_nummer :=0;
            FillChar(rest,SizeOf(rest),0);
            x_exe_zeiger:=stub_laenge;
          end;
        Move(exe_kopf,stub^[0],$40);
        CloseBST(ds);
      end
    else
      (* kein Stub *)
      if  (   (exe_kopf.sig='NE')
           or (exe_kopf.sig='LE')
           or (exe_kopf.sig='LX')
           or (exe_kopf.sig='PE'))
      (* auch andere 'sig' pruefen? *)
      and (MemW[Ofs(exe_kopf)+2]=0)
       then
        begin
          CloseBST(ds);
          Abbruch(textz_not_an_good_stub_file^);
        end
    else
      (* COM *)
      begin
        if FileSizeBST(ds)>64000 then
          begin
            CloseBST(ds);
            Abbruch(textz_Stub64k^);
          end;

        stub_laenge:=$40+FileSizeBST(ds);
        aufrunden(stub_laenge,16);
        GetMem(stub,stub_laenge);
        FillChar(stub^,stub_laenge,0);

        (* COM -> EXE *)
        with exe_kopf_typ(stub^[0]) do
          begin
            sig:='MZ';
            mod512:=FileSizeBST(ds) mod 512;
            page512:=FileSizeBST(ds) div 512;
            if mod512<>0 then Inc(page512);
            relo_anz:=0;
            kopfgroesse:=SizeOf(exe_kopf_typ) div 16;
            min:=$1000-((FileSizeBST(ds)+15) div 16);
            max:=$ffff;
            _ss:=$fff0;
            _sp:=$fffe;
            pruefsumme:=0;
            _ip:=$0100;
            _cs:=$fff0;
            relo_ofs:=0;
            ov_nummer:=0;
            FillChar(rest,SizeOf(rest),0);
            x_exe_zeiger:=stub_laenge;
          end;

        SeekBST(ds,0);
        BlockReadBST(ds,stub^[$40],FileSizeBST(ds));
        CloseBST(ds);
      end;


  end;


(*************************************************************************)
procedure anfang;
  var
    tmp                 :string;
    z1,z2               :longint;
    sw                  :char;
    n,e                 :string;
    searchpath          :PChar;
    foundfile           :array[0..260] of char;
  begin

    pruefe_umleitung;

    WriteLn('PE2LE '+currentversion+' * Veit Kannegieser * '+version);
    status(textz_pruefe_parameter^);

    // "D:\VP20" ausrechnen
    vp21_verzeichnis:=GetEnv('VPBASE');
    if vp21_verzeichnis='' then
      begin
        FSplit(ParamStr(0),vp21_verzeichnis,n,e);
        z1:=Length(vp21_verzeichnis)-Length('\BIN.???\'); (* or \OUT.???\ *)
        if (z1>0)
        and (       vp21_verzeichnis[z1+1] ='\')
        and (UpCase(vp21_verzeichnis[z1+2]) in ['B','O'])
        and (UpCase(vp21_verzeichnis[z1+3]) in ['I','U'])
        and (UpCase(vp21_verzeichnis[z1+4]) in ['N','T'])
        and (       vp21_verzeichnis[z1+5] ='.')
        and (       vp21_verzeichnis[z1+9] ='\') then
          SetLength(vp21_verzeichnis,z1);
      end;

    stub_name:='';
    beschreibung:='';
    resource_output:='';


    z1:=0;
    z2:=0;
    repeat
      Inc(z1);
      if z1>ParamCount then Break;

      if z2>2 then hilfe;

      tmp:=ParamStr(z1);


      if tmp='' then
        Continue;

      if tmp[1] in ['/','-'] then
        begin
          if Length(tmp)<Length('/S') then hilfe;
          sw:=UpCase(tmp[2]);
          Delete(tmp,1,Length('/S'));
          if Copy(tmp,1,1)=':' then
            Delete(tmp,1,Length(':'));
          if Copy(tmp,1,1)='"' then
            tmp:=Copy(tmp,2,Length(tmp)-2);
          case sw of
            'F':
              begin
                if tmp='LE' then
                  output_format:=le
                else if tmp='LX' then
                  output_format:=lx
                else hilfe
              end;
            'S':stub_name   :=tmp;
            'D':beschreibung:=tmp;
            'R':resource_output:=tmp;
            'Q':
                if tmp='' then
                  stumm:=ganz_stumm
                else if tmp='0' then
                  stumm:=ganz_stumm
                else if tmp='1' then
                  stumm:=normal
                else if tmp='2' then
                  stumm:=ausfuerlich;

            'P':if tmp='0' then
                  startcodewahl:=startcode_kein
                else if tmp='1' then
                  startcodewahl:=startcode_watcom
                else if tmp='2' then
                  startcodewahl:=startcode_relopack;
            // startcode_debug nur gewhlt wenn entsprechender Code gefunden
            // else if tmp='3' then
            //      startcodewahl:=startcode_debug;

            // VP 2.0 Release: nur ein %s mglich
            // nur zur Verwendung in VP.INI!
            '*':
              begin
                Inc(z2);
                le_name:=Copy(pe_name,1,Length(pe_name)-Length('.EXE'))+'.COM';
              end;

            'C':resource_codepage:=tmp;

          else
            hilfe;
          end;
        end
      else
        begin
          Inc(z2);
          case z2 of
           1:pe_name:=tmp;
           2:le_name:=tmp;
          end;
        end;
    until false;

    if (Pos('/',stub_name)=0) and (Pos('\',stub_name)=0) then
      begin (* stub_name non-empty, but without path *)

        GetMem(searchpath,Length(vp21_verzeichnis)+Length('\BIN.D32;')
                                +StrLen(GetEnvVar('PATH'))
{$IFDEF OS2}
                                +Length(';')+StrLen(GetEnvVar('DPATH'))
{$ENDIF}
                                +1);
        StrPCopy(searchpath,vp21_verzeichnis);
        StrCat(searchpath,'\BIN.D32;');
        StrCat(searchpath,GetEnvVar('PATH'));
{$IFDEF OS2}
        StrCat(searchpath,';');
        StrCat(searchpath,GetEnvVar('DPATH'));
{$ENDIF}

        FillChar(foundfile,SizeOf(foundfile),0);
        FileSearch(foundfile,@(stub_name+#0)[1],searchpath);
        if StrLen(foundfile)<>0 then
          stub_name:=StrPas(foundfile);
      end;

    db_name:=Copy(le_name,1,Length(le_name)-Length('.COM'))+'.DEB';

    if z2<>2 then hilfe;
  end;

procedure laden;



  var
    datei,
    res_datei           :pBufStream;
    puffer              :array[0..$3f] of char;
    p1                  :longint;
    i                   :SmallWord;
    new_size, fill_size :longint;

  procedure lies(var p:pByteArray;var obj:pe_obj_typ);
    begin
      GetMem(p,obj.physical_size);
      SeekBST(datei,obj.physical_offset);
      BlockReadBST(datei,p^,obj.physical_size);
    end;

  begin
    load_module_description(pe_name);

    FillChar(leer,SizeOf(leer),0);

    lies_stub(stub_name);

    status(textz_Reading_Source_Executable^);
    OpenReadBST(datei,pe_name);

    pe_start:=0;
    repeat
      BlockReadBST(datei,puffer,SizeOf(puffer));

      if gleich4(puffer, 'PE'#0#0) then break;
      if gleich4(puffer, 'PL'#0#0) then break; // VPT: Pharlap signature
      if gleich4(puffer, 'PX'#0#0) then break; // VPT: HX and DOS4G signature
      if gleich4(puffer, 'BPE'#0)  then break; // VPT: Unilink/Doswin32 signature

      if ((puffer[0]='M') and (puffer[1]='Z'))
      or ((puffer[0]='Z') and (puffer[1]='M'))
       then
        begin
          pe_start:=pLongint(@puffer[$3c])^;
          SeekBST(datei,pe_start);
          Continue;
        end;

      if gleich4(puffer, 'LX'#0#0) then
        Abbruch(textz_quelle_lx^);

      if gleich4(puffer, 'LE'#0#0) then
        Abbruch(textz_quelle_le^);

      Abbruch(textz_unknown_invalid_source_executable_format^);

    until false;

    SeekBST(datei,pe_start);
    BlockReadBST(datei,pe_kopf,SizeOf(pe_kopf));

    (* obj-Tabelle laden *)

    if pe_kopf.num_obj > 96 then
      Abbruch('Schade!');

    SeekBST(datei,pe_start+pe_kopf.nthdrsize+$18);
    for i:=0 to pe_kopf.num_obj - 1 do
      BlockReadBST(datei,pe_obj_tab_all[i],SizeOf(pe_obj_typ));

    pe_obj_tab[code32 ].name            := '.text'#0#0#0;
    pe_obj_tab[code32 ].virtual_size    := 0;
    pe_obj_tab[code32 ].rva             := pe_kopf.text_start;
    pe_obj_tab[code32 ].physical_size   := 0;
    pe_obj_tab[code32 ].physical_offset := 0;
    pe_obj_tab[code32 ].obj_flags       := scnCode;
    GetMem(code_puffer, pe_kopf.tsize);

    pe_obj_tab[const32].name            := '.data'#0#0#0;
    pe_obj_tab[const32].virtual_size    := 0;
    pe_obj_tab[const32].rva             := pe_kopf.data_start;
    pe_obj_tab[const32].physical_size   := 0;
    pe_obj_tab[const32].physical_offset := 0;
    pe_obj_tab[const32].obj_flags       := scnData;
    GetMem(data_puffer, pe_kopf.dsize);

    for i:=0 to pe_kopf.num_obj - 1 do
      begin
        {VPT: code section found}
        if ((pe_obj_tab_all[i].obj_flags and scnCode)=scnCode)
           (* and (pe_obj_tab_all[i].rva>=pe_kopf.text_start)
           and (pe_obj_tab_all[i].physical_size>0)
           and (pe_obj_tab_all[i].virtual_size>0) *)
           then
          begin
            if pe_kopf.text_start = 0 then {VPT: alink/blink bug}
              begin
                pe_kopf.text_start      := pe_obj_tab_all[i].rva;
                pe_obj_tab[code32 ].rva := pe_obj_tab_all[i].rva
              end;
            new_size := pe_obj_tab_all[i].physical_size
                     +  (pe_obj_tab_all[i].rva-pe_kopf.text_start);
            ReAllocMem(code_puffer,new_size);
            SeekBST(datei,pe_obj_tab_all[i].physical_offset);
            BlockReadBST
              (
                datei,
                code_puffer^[pe_obj_tab_all[i].rva-pe_kopf.text_start],
                pe_obj_tab_all[i].physical_size
              );
            fill_size := pe_obj_tab_all[i].rva
              - (pe_obj_tab[code32 ].rva + pe_obj_tab[code32 ].physical_size);
            if fill_size > 0 then
              FillChar(code_puffer^[pe_obj_tab[code32 ].physical_size], fill_size, $CC);
            pe_obj_tab[code32 ].physical_size   := new_size;
            pe_obj_tab[code32 ].virtual_size    :=
                        pe_obj_tab_all[i].virtual_size
                     +  (pe_obj_tab_all[i].rva-pe_kopf.text_start);
            if not code_vorhanden then
              pe_obj_tab[code32 ].physical_offset := pe_obj_tab_all[i].physical_offset;
            code_vorhanden:=true
          end;
        {VPT: data section found}
        if ((pe_obj_tab_all[i].obj_flags and scnData)=scnData)
           and ((pe_obj_tab_all[i].obj_flags and (scnDiscardable or scnShared))=0)
           and (pe_obj_tab_all[i].rva>=pe_kopf.data_start)
           and (pe_obj_tab_all[i].physical_size>0)
           (* and (pe_obj_tab_all[i].virtual_size>0) *)
           and (pe_obj_tab_all[i].name<>'.idata'#0#0)
           {VPT: many linkers have writeable '.idata'}
           then
          begin
            if pe_kopf.data_start = 0 then {VPT: alink/blink bug}
              begin
                pe_kopf.data_start      := pe_obj_tab_all[i].rva;
                pe_obj_tab[const32].rva := pe_obj_tab_all[i].rva
              end;
            new_size := pe_obj_tab_all[i].physical_size
                     +  (pe_obj_tab_all[i].rva-pe_kopf.data_start);
            ReAllocMem(data_puffer,new_size);
            SeekBST(datei,pe_obj_tab_all[i].physical_offset);
            BlockReadBST
              (
                datei,
                data_puffer^[pe_obj_tab_all[i].rva-pe_kopf.data_start],
                pe_obj_tab_all[i].physical_size
              );
            fill_size := pe_obj_tab_all[i].rva
              - (pe_obj_tab[const32].rva + pe_obj_tab[const32].physical_size);
            if fill_size > 0 then
              FillChar(data_puffer^[pe_obj_tab[const32].physical_size], fill_size, 0);
            pe_obj_tab[const32].physical_size    := new_size;
            pe_obj_tab[const32].virtual_size    :=
                        pe_obj_tab_all[i].virtual_size
                     +  (pe_obj_tab_all[i].rva-pe_kopf.data_start);
            if not data_vorhanden then
              pe_obj_tab[const32 ].physical_offset := pe_obj_tab_all[i].physical_offset;
            data_vorhanden:=true
          end;
        {VPT: import section found}
        if (pe_obj_tab_all[i].rva<=pe_kopf.import_table) and
           (pe_kopf.import_table<pe_obj_tab_all[i].rva+pe_obj_tab_all[i].physical_size) then
          begin
            pe_obj_tab[idata  ].name            := '.idata'#0#0;
            pe_obj_tab[idata  ].virtual_size    := pe_kopf.import_data_size;
            pe_obj_tab[idata  ].rva             := pe_kopf.import_table;
            pe_obj_tab[idata  ].physical_size   := pe_kopf.import_data_size;
            pe_obj_tab[idata  ].physical_offset := pe_obj_tab_all[i].physical_offset
                               + (pe_kopf.import_table - pe_obj_tab_all[i].rva);
            pe_obj_tab[idata  ].obj_flags       := pe_obj_tab_all[i].obj_flags;
            lies(idata_puffer,pe_obj_tab[idata]);
            importe_vorhanden:=true
          end;
        {VPT: fixup section found}
        if (pe_obj_tab_all[i].rva<=pe_kopf.fixup) and
           (pe_kopf.fixup<pe_obj_tab_all[i].rva+pe_obj_tab_all[i].physical_size) then
          begin
            pe_obj_tab[reloc  ].name            := '.reloc'#0#0;
            pe_obj_tab[reloc  ].virtual_size    := pe_kopf.fixup_size;
            pe_obj_tab[reloc  ].rva             := pe_kopf.fixup;
            pe_obj_tab[reloc  ].physical_size   := pe_kopf.fixup_size;
            pe_obj_tab[reloc  ].physical_offset := pe_obj_tab_all[i].physical_offset
                               + (pe_kopf.fixup - pe_obj_tab_all[i].rva);
            pe_obj_tab[reloc  ].obj_flags       := pe_obj_tab_all[i].obj_flags;
            lies(relo_puffer,pe_obj_tab[reloc]);
            relo_vorhanden:=true
          end;
        {VPT: resource section found}
        if (pe_obj_tab_all[i].rva<=pe_kopf.resource_table) and
           (pe_kopf.resource_table<pe_obj_tab_all[i].rva+pe_obj_tab_all[i].physical_size) then
          begin
            pe_obj_tab[res    ].name            := '.rsrc'#0#0#0;
            pe_obj_tab[res    ].virtual_size    := pe_kopf.resource_data_size;
            pe_obj_tab[res    ].rva             := pe_kopf.resource_table;
            pe_obj_tab[res    ].physical_size   := pe_kopf.resource_data_size;
            pe_obj_tab[res    ].physical_offset := pe_obj_tab_all[i].physical_offset
                               + (pe_kopf.resource_table - pe_obj_tab_all[i].rva);
            pe_obj_tab[res    ].obj_flags       := pe_obj_tab_all[i].obj_flags;
            lies(reso_puffer,pe_obj_tab[res]);
            resourcen_vorhanden:=true
          end;
        {VPT: bss section found}
        if ((pe_obj_tab_all[i].obj_flags and $80) <> 0) or
           ((pe_obj_tab_all[i].obj_flags and $60) =  0) then
          begin
            new_size := pe_obj_tab_all[i].rva + pe_obj_tab_all[i].virtual_size;
            if pe_obj_tab_all[i].rva < pe_kopf.data_start then
              begin {VPT: add BSS to CODE}
                if new_size > pe_obj_tab[code32].rva + pe_obj_tab[code32].virtual_size then
                  pe_obj_tab[code32].virtual_size := new_size - pe_obj_tab[code32].rva;
              end
            else
              begin {VPT: add BSS to CONST}
                if new_size > pe_obj_tab[const32].rva + pe_obj_tab[const32].virtual_size then
                  pe_obj_tab[const32].virtual_size := new_size - pe_obj_tab[const32].rva;
              end
          end;
        {VPT: To do following sections: EXPORT, DEBUG, TLS}
      end;

    if not (code_vorhanden and data_vorhanden and relo_vorhanden)
     then
      Abbruch(textz_nicht_mit_VP_2_0_erzeugt^);

    //if pe_obj_tab[idata  ].physical_size>$14 then
    //  WriteLn(textz_warnung_import^);

    if not importe_vorhanden then
      FillChar(pe_obj_tab[idata],SizeOf(pe_obj_typ),0);
    if not resourcen_vorhanden then
      FillChar(pe_obj_tab[res  ],SizeOf(pe_obj_typ),0);

    if module_description='' then
      for i:=0 to pe_kopf.num_obj - 1 do
        begin
          {VPT: search for description, first method}
          if ((pe_obj_tab_all[i].rva<=pe_kopf.image_description) and
             (pe_kopf.image_description<pe_obj_tab_all[i].rva+pe_obj_tab_all[i].physical_size))
             then
            begin
              if pe_kopf.description_size>255 then
                pe_kopf.description_size:=255;
              SeekBST(datei, pe_obj_tab_all[i].physical_offset
                + (pe_kopf.image_description - pe_obj_tab_all[i].rva));
              BlockReadBST(datei,module_description[1],pe_kopf.description_size);
              SetLength(module_description, pe_kopf.description_size);
            end;
          {VPT: search for description, second method}
          if pe_obj_tab_all[i].name = '.desc'#0#0#0 then
            begin
              if pe_obj_tab_all[i].physical_size>255 then
                pe_obj_tab_all[i].physical_size:=255;
              SeekBST(datei, pe_obj_tab_all[i].physical_offset);
              BlockReadBST(datei,module_description[1],pe_obj_tab_all[i].physical_size);
              SetLength(module_description, pe_obj_tab_all[i].physical_size);
            end;
        end;
    {VPT: trim and update description}
    while (module_description<>'') and (module_description[Length(module_description)] = #0) do
      Delete(module_description,Length(module_description),1);
    if beschreibung='' then
      beschreibung := module_description;

    CloseBST(datei);

    if resourcen_vorhanden and (resource_output<>'') then
      begin
        CreateBST(res_datei,resource_output);
        BlockWriteBST(res_datei,reso_puffer^,pe_obj_tab[res].physical_size);
        CloseBST(res_datei);
        Dispose(reso_puffer);
        reso_puffer:=nil;
        resourcen_vorhanden:=false;
      end;

    resident_name:=pe_name;
    while pos('\',resident_name)
         +pos('/',resident_name)
         +pos(':',resident_name)>0 do
      Delete(resident_name,1,1);

    while Pos('.',resident_name)>0 do
      SetLength(resident_name,Length(resident_name)-1);

    // suche DEB_LINK unit in der CODE-Bereich
    // und setzte dann startcodewahl=#3
    for p1:=0 to pe_obj_tab[code32].physical_size-SizeOf(suchmaske) do
      with suchmaske(code_puffer^[p1]) do
        if  (kennung1=$6f44d10b)
        and (kennung2=$7fc94572)
        and (kennung3=$9231cb94) then
          begin
            startcodewahl:=startcode_debug;
            deb_link_start:=p1;
            break;
          end;
  end;

procedure rechnen;
  const
    import_jmp_min      :longint=$7fffffff;
    import_jmp_max      :longint=$00000000;

  var
    relo_anzahl         :longint;
    z1,z2               :longint;
    fix_page_ofs        :longint;


  procedure add_fixup(const off:smallint;const rva:longint);
    type
      dpmi32_resource_typ=
        record
          zeiger        :longint;
          laenge        :longint;
          signatur      :array[0..3] of char;
        end;
      dpmi32_relocation_typ=
        record
          zeiger        :longint;
          sig1,
          sig2          :array[0..3] of char;
        end;

    var
      diese_relokation_ist_fuer_page:longint;
      gefunden_z        :pLongint;

    begin
      gefunden_z:=pLongint(@le_image^[rva+delta+off]);

      (* Relokationen zu .idata werden nicht bentigt *)
      if (import_jmp_min<=pe_kopf.image_base+rva+off) and (pe_kopf.image_base+rva+off<=import_jmp_max) then
        Exit;

      diese_relokation_ist_fuer_page:=1+((rva+delta+off) div 4096);

      if off<0 then
        Inc(diese_relokation_ist_fuer_page);


      if Fixup_page_table_z^[diese_relokation_ist_fuer_page]=$ffffffff then
        (* Anfang setzen *)
         Fixup_page_table_z^[diese_relokation_ist_fuer_page]:=le_relo_puffer_position;

      (* nur beim 1. Mal *)
      if off>=0 then
        begin
          Dec(gefunden_z^,pe_kopf.image_base-delta);

          (* Spezialbehandlung fr direkten Zugriff auf Resource

             type
               dpmi32_resource_typ=
                 record
                   zeiger:pointer;
                   laenge:longint;
                   signatur:array[0..3] of char;
                 end;

             Suche nach
                   @data:0
                   0
                   'RES?'

             Umformung durch PE2LE:

               zeiger:=Ofs(@resource);
               laenge:=FileSize('*.res');
               signatur:='RESO';                           *)

          if  resourcen_vorhanden
          and (dpmi32_resource_typ(gefunden_z^).laenge=0)
          and (dpmi32_resource_typ(gefunden_z^).signatur='RES?')
           then
            begin
              dpmi32_resource_typ(gefunden_z^).zeiger  :=info_block_tabelle[resource].ofs;
              dpmi32_resource_typ(gefunden_z^).laenge  :=info_block_tabelle[resource].phys_laenge;
              dpmi32_resource_typ(gefunden_z^).signatur:='RESO';
            end;
        end;

      Inc(relo_zaehler);
      (* 32 Bit Offset *)
      le_relo_puffer^[le_relo_puffer_position+0]:=$07;

      (* Position in der Seite: -3..4092 *)
      le_relo_puffer^[le_relo_puffer_position+2]:=lo(off);
      le_relo_puffer^[le_relo_puffer_position+3]:=hi(off);
      (* RELO Objekt # *)
      le_relo_puffer^[le_relo_puffer_position+4]:=1;

      if (gefunden_z^ and $ffff0000)=0 then
        begin
          (* kleine Variante *)
          le_relo_puffer^[le_relo_puffer_position+1]:=$00;
          pSmallWord(@le_relo_puffer^[le_relo_puffer_position+5])^:=gefunden_z^;
          Inc(le_relo_puffer_position,7);
        end
      else
        begin
          (* grosse Variante *)
          le_relo_puffer^[le_relo_puffer_position+1]:=$10;
          pLongint(@le_relo_puffer^[le_relo_puffer_position+5])^:=gefunden_z^;
          Inc(le_relo_puffer_position,9);
        end;

      (* Ende verschieben *)
      Fixup_page_table_z^[diese_relokation_ist_fuer_page+1]:=le_relo_puffer_position;
      if stumm=ausfuerlich then
        status(textz_Calculating_Fixup^+': '+Int2Hex(diese_relokation_ist_fuer_page,4)+':'+int2hex(off,4)+' <= 1:'+int2hex(gefunden_z^,8));
    end;

  var
    reso_temp_puffer    :pByteArray;
    reso_temp_laenge    :longint;
    p1,p2               :longint;

  (*******************************************************)

  (*$I IDATA.PAS*)
  (*$I RELOP.PAS*)
  begin
    if importe_vorhanden then
      begin
        status(textz_Importumwandlung^);
        idata_umwandlung;
        resourcen_vorhanden:=true;
      end;

    status(textz_Processing_Header^);

    stacklaenge:=pe_kopf.stack_commit_size;

    if resourcen_vorhanden then
      begin
        status(textz_konvertiere_resourcen^);
        (* Annahme: viel weniger Platz wird bentigt *)
        reso_temp_puffer:=nil;
        reso_temp_laenge:=0;

        konvertiere_resourcen(reso_puffer,pe_obj_tab[res].physical_size,pe_obj_tab[res].rva,
                              import_schreib_puffer,import_schreib_index,
                              reso_temp_puffer,reso_temp_laenge,resource_codepage);

        (* alten Puffer freigeben *)
        Dispose(reso_puffer);
        reso_puffer:=reso_temp_puffer;
        reso_temp_puffer:=nil;

        (* neue Lnge merken *)

        pe_obj_tab[res].virtual_size :=reso_temp_laenge;
        pe_obj_tab[res].physical_size:=reso_temp_laenge;

        status(textz_Processing_Header^);

      end;

    // wenn ntig code fr startcode_relopack in VPSYSD32.PAS suchen
    if startcodewahl=startcode_relopack then
      begin
        // rckwrts suchen damit bei mehrfachem Vorkommen
        // die Stelle in VPSysLow gefunden wird
        relopack_position_gefunden:=-1;
        for p1:=pe_obj_tab[code32].physical_size-( MemL[Ofs(start2)+0]
                                                  -MemL[Ofs(start2)+4]) downto 0 do
          (* call ...    $e8 $07 $00 $00 $00 *)
          if pLongint(@code_puffer^[p1])^=$000007e8 then
            begin
              relopack_position_gefunden:=p1;

              for p2:=MemL[Ofs(start2)+0]
                     -MemL[Ofs(start2)+4] downto 0 do
                if Mem[Ofs(start2)+8+p2]<>code_puffer^[p1+p2] then
                  begin
                    relopack_position_gefunden:=-1; (* keine bereinstimmung   *)
                    break;  (* Teilvergleich abbrechen *)
                  end;

              if relopack_position_gefunden<>-1 then (* bereinstimmung *)
                begin
                  startcodewahl:=startcode_relopack__code_schon_vorhanden;
                  Break;     (* Suche war erfolgreich *)
                end;
            end;
      end;


    // code starter
    info_block_tabelle[startcode].ofs                   :=0;
    case startcodewahl of
      startcode_kein:
        info_block_tabelle[startcode].phys_laenge       :=0;
      startcode_watcom:
        info_block_tabelle[startcode].phys_laenge       :=MemL[Ofs(start1)+0]-MemL[Ofs(start1)+4];
      startcode_relopack:
        info_block_tabelle[startcode].phys_laenge       :=MemL[Ofs(start2)+0]-MemL[Ofs(start2)+4];
      startcode_debug:
        info_block_tabelle[startcode].phys_laenge       :=MemL[Ofs(start3)+0]-MemL[Ofs(start3)+4];
      startcode_relopack__code_schon_vorhanden:
        info_block_tabelle[startcode].phys_laenge       :=0;
    end;
    // only align 32 bit not Page to minimize image size
    info_block_tabelle[startcode].log_laenge            :=aufrundenf(info_block_tabelle[startcode].phys_laenge,4);

    // resources
    info_block_tabelle[resource].ofs                    :=info_block_tabelle[startcode].ofs
                                                         +info_block_tabelle[startcode].log_laenge;
    if resourcen_vorhanden then
      info_block_tabelle[resource].phys_laenge          :=reso_temp_laenge
    else
      info_block_tabelle[resource].phys_laenge          :=0;
    info_block_tabelle[resource].log_laenge             :=
                                              aufrundenf(info_block_tabelle[resource].ofs
                                                        +info_block_tabelle[resource].phys_laenge,
                                                        4096)-info_block_tabelle[resource].ofs;

    // normal code
    info_block_tabelle[code].ofs                        :=info_block_tabelle[resource].ofs
                                                         +info_block_tabelle[resource].log_laenge;
    info_block_tabelle[code].phys_laenge                :=pe_obj_tab[code32].physical_size;
    info_block_tabelle[code].log_laenge                 :=pe_obj_tab[const32].rva - pe_obj_tab[code32].rva;
                                                        // VPT: NB! tlink compatibility
                                                        (*was aufrundenf(pe_obj_tab[code32].virtual_size,pe_kopf.object_align)*)
    // data
    info_block_tabelle[daten].ofs                       :=info_block_tabelle[code].ofs
                                                         +info_block_tabelle[code].log_laenge;
    info_block_tabelle[daten].phys_laenge               :=pe_obj_tab[const32].physical_size;
    info_block_tabelle[daten].log_laenge                :=aufrundenf(pe_obj_tab[const32].virtual_size,4096);

    // sum
    info_block_tabelle[alles_zusammen].ofs              :=info_block_tabelle[startcode].ofs;
    info_block_tabelle[alles_zusammen].phys_laenge      :=info_block_tabelle[daten].ofs
                                                         +info_block_tabelle[daten].phys_laenge;

    info_block_tabelle[alles_zusammen].log_laenge       :=info_block_tabelle[daten].ofs
                                                         +info_block_tabelle[daten].log_laenge;

    getmem  (le_image ,info_block_tabelle[alles_zusammen].phys_laenge);
    FillChar(le_image^,info_block_tabelle[alles_zusammen].phys_laenge,0);

    // VPT: Es ist moeglich, pe_kopf.text_start<>$1000
    eip_pos:=pe_kopf.entrypoint-pe_kopf.text_start+info_block_tabelle[code].ofs;

    // erstmal ..,code,.. kopieren damit die Variante 'relopack_position_gefunden'
    // auch die gesuchten stellen im Speicher findet und ndern kann

    // move resource ...
    if resourcen_vorhanden then
      begin
        Move(reso_puffer^,
             le_image^[info_block_tabelle[resource].ofs],
             info_block_tabelle[resource].phys_laenge);
        Dispose(reso_puffer);
        reso_puffer:=nil;
      end;

    // move code ...
    Move(code_puffer^,
         le_image^[info_block_tabelle[code].ofs],
         info_block_tabelle[code].phys_laenge);
    Dispose(code_puffer);
    code_puffer:=nil;


    // startcode ...
    case startcodewahl of
      (****************************************************************)
      startcode_kein:
        ;

      (****************************************************************)
      startcode_watcom:
        begin
          Move(Mem[Ofs(start1)+8],
               le_image^[info_block_tabelle[startcode].ofs],
               info_block_tabelle[startcode].phys_laenge);
          MemL[Ofs(le_image^[info_block_tabelle[startcode].ofs+1])]:=eip_pos-5;
          eip_pos:=info_block_tabelle[startcode].ofs; // 0
        end;

      (****************************************************************)
      startcode_relopack:
        begin
          le_image_startcode:=info_block_tabelle[startcode].ofs;
          Move(Mem[Ofs(start2)+8],
               le_image^[le_image_startcode],
               info_block_tabelle[startcode].phys_laenge);

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('5'))
                     and (le_image^[z1+2]=Ord('5'))
                     and (le_image^[z1+1]=Ord('5'))
                     and (le_image^[z1+0]=Ord('5'))) do
            Inc(z1);
          (* relativer Abstand von relo code +5 zum Anfang des Programmspeichers *)
          MemL[Ofs(le_image^[z1])]:=le_image_startcode+5;

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('E'))
                     and (le_image^[z1+2]=Ord('I'))
                     and (le_image^[z1+1]=Ord('P'))
                     and (le_image^[z1+0]=Ord(' '))) do
            Inc(z1);
          MemL[Ofs(le_image^[z1])]:=eip_pos;
          // relopack_ofs spter
          eip_pos:=le_image_startcode; // 0
        end;

      (****************************************************************)
      startcode_relopack__code_schon_vorhanden:
        begin
          le_image_startcode:=info_block_tabelle[code].ofs+relopack_position_gefunden;

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('5'))
                     and (le_image^[z1+2]=Ord('5'))
                     and (le_image^[z1+1]=Ord('5'))
                     and (le_image^[z1+0]=Ord('5'))) do
            Inc(z1);
          (* relativer Abstand von relo code +5 zum Anfang des Programmspeichers *)
          MemL[Ofs(le_image^[z1])]:=le_image_startcode+5;

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('E'))
                     and (le_image^[z1+2]=Ord('I'))
                     and (le_image^[z1+1]=Ord('P'))
                     and (le_image^[z1+0]=Ord(' '))) do
            Inc(z1);
          MemL[Ofs(le_image^[z1])]:=eip_pos;
          // relopack_ofs spter
          eip_pos:=le_image_startcode;
        end;

      (****************************************************************)
      startcode_debug:
        begin
          with suchmaske(le_image^[info_block_tabelle[code].ofs+deb_link_start]) do
            begin
              // VPT: Es ist moeglich, pe_kopf.image_base<>$400000
              eip:=pe_kopf.image_base+pe_kopf.entrypoint;
              eip_pos:=info_block_tabelle[code].ofs+deb_link_start+Ofs(opcode)-Ofs(kennung1);
            end;

          le_image_startcode:=info_block_tabelle[startcode].ofs;
          Move(Mem[Ofs(start3)+8],
               le_image^[le_image_startcode],
               info_block_tabelle[startcode].phys_laenge);

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('E'))
                     and (le_image^[z1+2]=Ord('I'))
                     and (le_image^[z1+1]=Ord('P'))
                     and (le_image^[z1+0]=Ord(' '))) do
            Inc(z1);
          MemL[Ofs(le_image^[z1])]:=eip_pos;
          // relopack_ofs spter
          eip_pos:=le_image_startcode; // 0

          if resourcen_vorhanden then
            begin
              z1:=le_image_startcode;
              while not (    (le_image^[z1+3]=Ord('R'))
                         and (le_image^[z1+2]=Ord('E'))
                         and (le_image^[z1+1]=Ord('O'))
                         and (le_image^[z1+0]=Ord('F'))) do
                Inc(z1);
              MemL[Ofs(le_image^[z1])]:=info_block_tabelle[resource].ofs;
            end;

          z1:=le_image_startcode;
          while not (    (le_image^[z1+3]=Ord('C'))
                     and (le_image^[z1+2]=Ord('O'))
                     and (le_image^[z1+1]=Ord('D'))
                     and (le_image^[z1+0]=Ord('E'))) do
          Inc(z1);
          MemL[Ofs(le_image^[z1])]:=info_block_tabelle[code].ofs;

        end;


    end;
    (******************************************************************)

    // den Rest auch noch dazukopieren ...

    // move const ...
    Move(data_puffer^,
         le_image^[info_block_tabelle[daten].ofs],
         info_block_tabelle[daten].phys_laenge);
    Dispose(data_puffer);
    data_puffer:=nil;

    (* Differenz zwischen neuer und alter position von Code32 *)
    delta:=info_block_tabelle[code].ofs-pe_obj_tab[code32].rva;

    (* Object Table einrichten *)
    with le_obj_1 do
      begin
        virtual_size_in_bytes   :=info_block_tabelle[alles_zusammen].log_laenge;
        relocation_base_address :=ziel_va;
        object_flags            :=(1 shl  0) // read
                            //!! +(1 shl  1) // write
                                 +(1 shl  2) // executable
                                 +(1 shl 13);// use32
        page_map_index          :=1;
        page_map_entries        :=pages(info_block_tabelle[alles_zusammen].phys_laenge);
        FillChar(reserved,SizeOf(reserved),0);
      end;

    // le_obj_2 (Stack) wird erst nach RELOPACK berechnet




    (* Object Page Map Table einrichten *)
    page_map_table_entries:=le_obj_1.page_map_entries;

    if output_format=le
      then
        begin
          GetMem  (Object_Page_Map_Table_feld_z ,page_map_table_entries*SizeOf(le_page_map_entry_typ));
          FillChar(Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(le_page_map_entry_typ),0);
          for z1:=1 to page_map_table_entries do
            with le_page_map_entry_feld_z_typ(Object_Page_Map_Table_feld_z)^[z1] do
              index_into_fixup_table:=pack24bit(z1);
        end
      else
        begin
          GetMem  (Object_Page_Map_Table_feld_z ,page_map_table_entries*SizeOf(lx_page_map_entry_typ));
          FillChar(Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(lx_page_map_entry_typ),0);
          for z1:=1 to page_map_table_entries do
            with lx_page_map_entry_feld_z_typ(Object_Page_Map_Table_feld_z)^[z1] do
              begin
                index_into_fixup_table:=z1-1;
                data_size:=$1000
              end;
          with lx_page_map_entry_feld_z_typ
               (Object_Page_Map_Table_feld_z)^[page_map_table_entries] do
           data_size:=info_block_tabelle[alles_zusammen].phys_laenge mod 4096;
        end;

    (* Fixup page table einrichten *)
    GetMem(Fixup_page_table_z,(page_map_table_entries+1)*SizeOf(longint));
    FillChar(Fixup_page_table_z^,(page_map_table_entries+1)*SizeOf(longint),$ff);

    GetMem(le_relo_puffer,pe_obj_tab[reloc].physical_size*9); (* Faktor 9 ist sicher .. *)
    le_relo_puffer_position:=0;
    (* Relokationen umrechen *)
    z2:=0;
    status(textz_Calculating_Fixup^+' ...');
    while z2<pe_obj_tab[reloc].virtual_size do
      with pe_relo_z_typ(@relo_puffer^[z2])^ do
        begin
          // VPT: Wollen wir unendliche Zykle brechen?
          if block_size=0 then break;
          for z1:=1 to (block_size-8) div 2 do
            begin
              fix_page_ofs:=fixup[z1] and $fff;
              case (fixup[z1] shr 12) of
                $0:;(* NOP     *)
                $1: (* HIGH    *)
                  Abbruch(textz_unsupportes_fixup_type^+' ($1xxx)!');
                $2: (* LOW     *)
                  Abbruch(textz_unsupportes_fixup_type^+' ($2xxx)!');
                $3: (* HIGHLOW *)
                  begin
                    add_fixup(fix_page_ofs,page_rva);
                    if fix_page_ofs>4096-4 then
                      add_fixup(fix_page_ofs-4096,page_rva+4096);
                  end;
              else
                Abbruch(textz_unsupportes_fixup_type^+'!');
              end;
            end;

          Inc(z2,block_size);
        end; (* ".reloc" *)

    Dispose(relo_puffer);
    relo_puffer:=nil;

    (* Auch fr reine Seiten 0=x-x Fixup-Eintrge *)
    Fixup_page_table_z^[page_map_table_entries+1]:=le_relo_puffer_position;
    for z1:=page_map_table_entries downto 2 do
      if Fixup_page_table_z^[z1]=$ffffffff then
        Fixup_page_table_z^[z1]:=Fixup_page_table_z^[z1+1];
    Fixup_page_table_z^[1]:=0;

    if le_relo_puffer_position>0 then
    if startcodewahl in [startcode_relopack,
                         startcode_debug,
                         startcode_relopack__code_schon_vorhanden] then
      relokations_kompressor;

    status(textz_Processing_Header^);

    // Parameter fr Speicherlschen eintragen
    if startcodewahl in [startcode_relopack,
                         startcode_relopack__code_schon_vorhanden,
                         startcode_debug] then
      begin
        z1:=le_image_startcode;
        while not (    (le_image^[z1+3]=Ord('V')) (* 'VAR0' *)
                   and (le_image^[z1+2]=Ord('A'))
                   and (le_image^[z1+1]=Ord('R'))
                   and (le_image^[z1+0]=Ord('0'))) do
          Inc(z1);

        MemL[Ofs(le_image^[z1])]:=( info_block_tabelle[alles_zusammen].ofs
                                   +info_block_tabelle[alles_zusammen].log_laenge)
                                 -( info_block_tabelle[daten         ].ofs
                                   +info_block_tabelle[daten         ].phys_laenge);
      end;


    // stack
    with le_obj_2 do
      begin
        virtual_size_in_bytes   :=stacklaenge;
        relocation_base_address :=
                       aufrundenf(le_obj_1.relocation_base_address
                                 +aufrundenf(le_obj_1.virtual_size_in_bytes,4096),64*1024);
        object_flags            :=(1 shl  0) // read
                                 +(1 shl  1) // write
                              // +(1 shl  2) // executable
                                 +(1 shl 13);// use32
        page_map_index          :=le_obj_1.page_map_entries+1;
        page_map_entries        :=0;
        FillChar(reserved,SizeOf(reserved),0);
      end;

(*
    LE-KOPF
    OBJ-TABLE           [1]
                        [2]
    PAGE-MAP            [1]
                        [2]
    RESIDENT_NAME       String , 3 Byte Null
    ENTRY_TABLE         1 Byte 0
    FIXUP_PAGE_TABLE    [1]
                        ..
                        [y]
    FIXUP_RECORD_TABLE  [1]
                        ..
                        [y]
    IMPORTED___         3 Byte
    NONERESNAME         ...
    DATA_PAGES          ...
               *)

    FillChar(le_kopf,SizeOf(le_kopf),0);

    with le_kopf do
      begin
        if output_format=le then
          sig:='LE'
        else
          sig:='LX';
        cpu_typ:=2; (* 386+ *) {?}
        target_os:=1; (* OS/2 (DPMI) *)
        module_version:=$20cd16cd; (* Int 16, Int 20 *)
        module_type:=2 shl 8; (* "PM-kompatibel" *)
        number_of_memory_pages:=page_map_table_entries;
        cs_obj_nummer:=1;
        eip_obj_ofs:=eip_pos;
        ss_obj_nummer:=2;
        esp_obj_ofs:=stacklaenge;
        memory_page_size:=4096;
        if output_format=le then
          bytes_on_last_page              :=info_block_tabelle[alles_zusammen].phys_laenge mod 4096
        else
          bytes_on_last_page:=12;
        offset_of_object_table          :=SizeOf(le_kopf);
        object_table_entries            :=2;
        object_page_map_table_offset    :=offset_of_object_table
                                         +object_table_entries*SizeOf(le_obj_typ);
        if output_format=le then
          resident_names_table_offset     :=object_page_map_table_offset
                                         +page_map_table_entries*SizeOf(le_page_map_entry_typ)
        else
          resident_names_table_offset     :=object_page_map_table_offset
                                         +page_map_table_entries*SizeOf(lx_page_map_entry_typ);
        entry_table_offset              :=resident_names_table_offset
                                         +Length(resident_name)+1
                                         +SizeOf(resident_name_term);
        Fixup_page_table_offset         :=entry_table_offset
                                         +1;
        Fixup_record_table_offset       :=Fixup_page_table_offset
                                         +(page_map_table_entries+1)*SizeOf(longint);
        imported_modules_name_table_offset:=Fixup_record_table_offset
                                         +le_relo_puffer_position;
        imported_procedures_name_table_offset:=imported_modules_name_table_offset;

        data_pages_offset               :=imported_procedures_name_table_offset
                                         +3;

        nonresident_names_table_offset  :=data_pages_offset
                                         +info_block_tabelle[alles_zusammen].phys_laenge;

        nonresident_names_table_length  :=Length(beschreibung)+1+3;

        fixup_section_size :=le_relo_puffer_position+(page_map_table_entries+1)*SizeOf(longint)+1;
        loader_section_size:=Fixup_page_table_offset+fixup_section_size-offset_of_object_table;
        automatic_data_object:=2; // wie wlinkw.exe
      end;


    with le_kopf do
      begin
        Inc(data_pages_offset                   ,stub_laenge);
        if nonresident_names_table_offset>0 then
          Inc(nonresident_names_table_offset    ,stub_laenge);
      end;
  end;

procedure speichern;

  function zahldarstellung(const i:longint):string;
    var
      zaehler           :longint;
      tmp               :string;
    begin
      tmp:=int2strz(i,10);
      zaehler:=1;
      while (tmp[zaehler]='0') and (zaehler<Length(tmp)) do
        begin
          tmp[zaehler]:=' ';
          Inc(zaehler);
        end;
      zahldarstellung:=tmp;
    end;

  var
    datei               :pBufStream;
    datei_ft            :file;
    sum_header          :longint;
    diff                :longint;
    ft                  :longint;
  begin
    status(textz_Writing_Target^);
    CreateBST(datei,le_name);
    if stub_laenge>0 then
      BlockWriteBST(datei,stub^,stub_laenge);
    BlockWriteBST(datei,le_kopf,SizeOf(le_kopf));
    BlockWriteBST(datei,le_obj_1,SizeOf(le_obj_1));
    BlockWriteBST(datei,le_obj_2,SizeOf(le_obj_2));
    if output_format=le then
      BlockWriteBST(datei,Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(le_page_map_entry_typ))
    else
      BlockWriteBST(datei,Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(lx_page_map_entry_typ));
    BlockWriteBST(datei,resident_name,Length(resident_name)+1);
    BlockWriteBST(datei,resident_name_term,SizeOf(resident_name_term));
    BlockWriteBST(datei,entry_table,SizeOf(entry_table));
    BlockWriteBST(datei,Fixup_page_table_z^,(page_map_table_entries+1)*SizeOf(longint));
    if le_relo_puffer_position>0 then
      BlockWriteBST(datei,le_relo_puffer^,le_relo_puffer_position);
    BlockWriteBST(datei,import___,SizeOf(import___));
    BlockWriteBST(datei,le_image^,info_block_tabelle[alles_zusammen].phys_laenge);
    BlockWriteBST(datei,beschreibung,Length(beschreibung)+1);
    BlockWriteBST(datei,beschreibung_term,SizeOf(beschreibung_term));
    CloseBST(datei);

    if output_format=le then
      sum_header:=SizeOf(le_kopf)
               +SizeOf(le_obj_1)
               +SizeOf(le_obj_1)
               +page_map_table_entries*SizeOf(le_page_map_entry_typ)
               +Length(resident_name)+1
               +SizeOf(resident_name_term)
               +SizeOf(entry_table)
               // fixup page table
               +(page_map_table_entries+1)*SizeOf(longint)
               +SizeOf(import___)
    else
      sum_header:=SizeOf(le_kopf)
               +SizeOf(le_obj_1)
               +SizeOf(le_obj_1)
               +page_map_table_entries*SizeOf(lx_page_map_entry_typ)
               +Length(resident_name)+1
               +SizeOf(resident_name_term)
               +SizeOf(entry_table)
               // fixup page table
               +(page_map_table_entries+1)*SizeOf(longint)
               +SizeOf(import___);


    status(textz_Erfolgreich_beendet^);
    WriteLn('');

    if stumm<>ganz_stumm then
      begin

        WriteLn(  ' * '+zahldarstellung(stub_laenge)+                   ' Byte Stub');
        WriteLn(  ' * '+zahldarstellung(sum_header)+                    ' Byte LE Header '+textz_ohne^+' Fixup');
        if le_relo_puffer_position>0 then
          WriteLn(' * '+zahldarstellung(le_relo_puffer_position)+       ' Byte Fixup ('+zahldarstellung(relo_zaehler)+')');
        WriteLn(  ' * '+zahldarstellung(info_block_tabelle[startcode].phys_laenge)+
                                                                        ' Byte startup code');

        diff:=info_block_tabelle[resource].ofs
             -info_block_tabelle[startcode].ofs
             -info_block_tabelle[startcode].phys_laenge;
        if diff>0 then
          WriteLn(' * '+zahldarstellung(diff)+                          ' Byte '+textz_pagefill^);

        WriteLn(  ' * '+zahldarstellung(info_block_tabelle[resource].phys_laenge)+
                                                                        ' Byte Resource');

        diff:=info_block_tabelle[code].ofs
             -info_block_tabelle[resource].ofs
             -info_block_tabelle[resource].phys_laenge;
        if diff>0 then
          WriteLn(' * '+zahldarstellung(diff)+                          ' Byte '+textz_pagefill^);

        WriteLn(  ' * '+zahldarstellung(info_block_tabelle[code].phys_laenge)+
                                                                        ' Byte Code');

        diff:=info_block_tabelle[daten].ofs
             -info_block_tabelle[code].ofs
             -info_block_tabelle[code].log_laenge;
        if diff>0 then
          WriteLn(' * '+zahldarstellung(diff)+                          ' Byte '+textz_pagefill^);

        if relopacklaenge>0 then
          WriteLn(' * '+zahldarstellung(relopacklaenge)+                ' Byte Relopack ('+zahldarstellung(relo_zaehler)+')');

        WriteLn(  ' * '+zahldarstellung(Length(beschreibung)+1
                            +SizeOf(beschreibung_term))+                ' Byte '+textz_Exe_Description^);

      end;

    if startcodewahl=startcode_debug then
      begin

        CreateBST(datei,db_name);

        // size of code.. segment
        diff:=info_block_tabelle[daten].ofs-info_block_tabelle[code].ofs;
        BlockWriteBST(datei,diff,4);

        // size of const/locinfo/data segment
        diff:=info_block_tabelle[daten].log_laenge;
        BlockWriteBST(datei,diff,4);
        CloseBST(datei);

        // Zeitstempel der LE-Datei holen
        Assign(datei_ft,le_name);
        FileMode:=open_share_DenyNone+open_access_ReadOnly;
        Reset(datei_ft,1);
        GetFTime(datei_ft,ft);
        Close(datei_ft);


        // gleicher Zeitstempel in der .deb-Datei
        Assign(datei_ft,db_name);
        FileMode:=open_access_ReadWrite+open_share_DenyNone;
        Reset(datei_ft,1);
        SetFTime(datei,ft);
        Close(datei_ft);
      end;

    if stub_laenge>0 then
      begin
        Dispose(stub);
        stub:=nil;
      end;
    Dispose(Object_Page_Map_Table_feld_z);
    Dispose(Fixup_page_table_z);
    if le_relo_puffer_position>0 then
      begin
        Dispose(le_relo_puffer);
        le_relo_puffer:=nil;
      end;

    Dispose(le_image);
    le_image:=nil;
  end;

begin
  (*$IFDEF LINUX*)
  FileSystem := fsDos;
  (*$ENDIF*)

  anfang;
  laden;
  rechnen;
  speichern;
  Write(^Z);
end.

