(* V.K. 04.10.1996 *)
(* 23.10.1996 Kennung *)
(* 11.03.1998 SET COUNTRY=0?? *)
(* 03.11.1998 DPMI32 *)
(* 09.12.1998 WIN32: country=1; *)
(* 1999.11.20 Sprache 2 *)
(* 2000.01.06 DPMI(16) *)
(* 2000.01.06 DPMI(16): INT21/48->INT31/01 *)
(* 2000.01.07 DPMI(16): Intr->INT31/03 *)
(* 2001.03.17 Laden aus einer Datei *)
(* 2001.10.19 O+ *)

(*&USE32+*)
{$O+}

unit spr2_aus;

interface

procedure setze_sprachzeiger(const datenobjekt,zeiger_adresse:pointer);
procedure setze_sprachzeiger_aus_datei(const dateiname:string;zeiger_adresse:pointer);

implementation

uses
  (*$IFDEF VIRTUALPASCAL*)
  (*$IFDEF OS2*)
  Os2Base,Os2Def,
  (*$ENDIF*)
  (*$IFDEF DPMI32*)
  dpmi32,dpmi32df,
  (*$ENDIF*)
  (*$ENDIF*)
  dos;


(*$I SPR2_DAT*)

var
  country_nummer:word;

(*$IFDEF VIRTUALPASCAL*)

(*$IFDEF DPMI32*)
procedure bestimme_country_code;assembler;(*$FRAME-*)(*$USES EAX,ESI*)
  var
    reg:real_mode_call_structure_typ;
  asm
    lea esi,reg
    mov [esi+real_mode_call_structure_typ.ax_],$3800 // get Country-specific info
    mov ax,segdossyslow16
    mov [esi+real_mode_call_structure_typ.ds_],ax    // DS:DX
    mov [esi+real_mode_call_structure_typ.dx_],0
    mov [esi+real_mode_call_structure_typ.bx_],0
    push esi
    push $21
    call intr_realmode
    movzx eax,word [esi+real_mode_call_structure_typ.bx_]
    mov country_nummer,eax
  end;

(*$ENDIF*)

(*$IFDEF OS2*)
procedure bestimme_country_code;
  var
    Country   : COUNTRYCODE; (* Country code info (0 = current country) *)
    CtryInfo  : COUNTRYINFO; (* Buffer for country-specIfic information *)
    ulInfoLen : ULONG;
    rc        : APIRET;      (* Return code                             *)
  begin
    ulInfoLen := 0;
    rc        := NO_ERROR;

    FillChar(Country,SizeOf(Country),0);
    FillChar(CtryInfo,SizeOf(CtryInfo),0);

    rc := DosQueryCtryInfo(sizeof(CtryInfo), Country,
                           CtryInfo, ulInfoLen);
    if (rc=0) and (CtryInfo.country<=$ffff) then
      country_nummer:=CtryInfo.country+0
    else
      country_nummer:=49;

  end;
(*$ENDIF*)

(*$IFDEF WIN32*)
procedure bestimme_country_code;
  begin
    country_nummer:=1; (* do not know -> use SET LANG=... *)
  end;
(*$ENDIF*)

(*$IFDEF Linux*)
procedure bestimme_country_code;
  begin
    country_nummer:=1; (* do not know -> use SET LANG=... *)
  end;
(*$ENDIF*)

(*$ELSE*)
procedure bestimme_country_code;
  var
    (*$IFDEF DPMI*)
    country_seg,
    country_sel:word;
    (*$ELSE*)
    country_puffer:array[1..40] of byte;
    (*$ENDIF*)

  (*$IFDEF DPMI*)
  type
    real_mode_call_structure_typ=
      packed record
        case longint of
          0:(edi_,esi_,ebp_,res1,ebx_,edx_,ecx_,eax_:longint;
             flags_,es_,ds_,fs_,gs_,ip_,cs_,sp_,ss_:word;);
          1:(di_,hdi_,si_,hsi_,bp_,hbp_,res2,res3,bx_,hbx_,dx_,hdx_,cx_,hcx_,ax_,hax_:word);
          2:(res4:array[0..15] of byte;bl_,bh_:byte;res5:word;dl_,dh_:byte;res6:word;cl_,ch_:byte;res7:word;al_,ah_:byte);
      end;

  procedure intr_realmode(var reg:real_mode_call_structure_typ;i_num:byte);
    begin
      reg.res1:=0;
      asm
        mov ax,$0300 (* Simulate Real Mode Interrupt *)
        mov bl,i_num
        mov bh,0
        sub cx,cx    (* CX=0 (Stack push..) *)
        les di,reg
        int $31
      end;
    end;

  var
    r2:real_mode_call_structure_typ;
  (*$ENDIF*)

  begin
    (*$IFDEF DPMI*)
    asm
      mov ax,$0100              (* DPMI: DOS Speicher anfordern *)
      mov bx,131                (* 2096>2048+40 Byte *)
      int $31
      jnc @l1
      sub bx,bx
    @l1:
      mov country_seg,ax
      mov country_sel,dx
    end;

    if country_sel=0 then
      RunError(8);

    with r2 do
      begin
        FillChar(r2,SizeOf(r2),0);
        ax_:=$3800;
        ds_:=country_seg;       (* -> DS:DX *)
        dx_:=0;
        ss_:=country_seg;       (* SS:SP (1 KB) *)
        sp_:=2096-16;
        intr_realmode(r2,$21);
        country_nummer:=bx_;
      end;

    asm
      mov ax,$0101              (* DPMI: DOS Speicher freigeben *)
      mov dx,country_sel
      int $31
    end;
    (*$ELSE*)
    asm
      push ds
        mov ax,$3800
        mov dx,offset country_puffer
        push ss
        pop ds
        int $21
      pop ds
      mov country_nummer,bx
    end;
    (*$ENDIF*)
  end;
(*$ENDIF*)


procedure setze_sprachzeiger(const datenobjekt,zeiger_adresse:pointer);
  var
    auswahl             :word;

    lese_zeiger         :str_z;
    lese_zeiger_longint :longint absolute lese_zeiger;

    schreib_zeiger      :^str_z;

    z1,z2               :word;

    sprache             :string[2];
    anzahl_sprachen     :word;
    anzahl_elemente     :word;

  type
    (*$IFDEF VIRTUALPASCAL*)
    word_z              =^smallword;
    (*$ELSE*)
    word_z              =^word;
    (*$ENDIF*)

  begin
    bestimme_country_code;

    sprache:=Copy(GetEnv('LANG'),1,2);

    if sprache='' then
      case country_nummer of
        049,     (* BRD *)
        041,     (* Schweiz,fr+de *)
        043:     (* sterreich *)
          sprache:='DE';

        033,     (* Frankreich *)
        002:     (* Kanada fr. *)
          sprache:='FR';

        007:
          sprache:='RU';

        022,     (* Spanien *)
        052..055,(* Mexiko/Kuba/Argentinien/Brasilien *)
        057:     (* Kolumbien *)
          sprache:='ES';
      else
          sprache:='EN';
      end;

    sprache[1]:=UpCase(sprache[1]);
    sprache[2]:=UpCase(sprache[2]);

    lese_zeiger:=datenobjekt;
    schreib_zeiger:=zeiger_adresse;
    Inc(schreib_zeiger);

    (* Anfang suchen *)
    while str_z(lese_zeiger)^<>spra_kennung do
      Inc(lese_zeiger_longint,1);

    Inc(lese_zeiger_longint,length(spra_kennung)+1);

    (* passenden Sprachindex suchen *)
    anzahl_sprachen:=Length(str_z(lese_zeiger)^) div Length('DE');
    auswahl:=anzahl_sprachen;
    while (auswahl>1) and (Copy(str_z(lese_zeiger)^,2*auswahl-1,2)<>sprache) do
      Dec(auswahl);

    Inc(lese_zeiger_longint,1+2*anzahl_sprachen);

    anzahl_elemente:=word_z(@lese_zeiger^)^;
    Inc(lese_zeiger_longint,2);

    z1:=anzahl_elemente;
    while z1>0 do
      begin
        for z2:=1 to anzahl_sprachen do
          begin
            if z2=auswahl then
              begin
                schreib_zeiger^:=lese_zeiger;
                Inc(schreib_zeiger);
              end;
            Inc(lese_zeiger_longint,1+Length(lese_zeiger^));
          end;
        Dec(z1);
      end;

  end;

procedure setze_sprachzeiger_aus_datei(const dateiname:string;zeiger_adresse:pointer);
  var
    d                   :file;
    fehler              :integer;
    voller_name         :string;
    speicher            :pointer;
    org_FileMode        :word;
    dateilaenge         :longint;

  procedure oeffne;
    begin

      if voller_name='' then
        begin
          fehler:=2; (* nicht gefunden *)
          Exit;
        end;

      Assign(d,voller_name);
      (*$I-*)
      Reset(d,1);
      (*$I+*)
      fehler:=IOResult;
    end;

  begin
    org_FileMode:=FileMode;
    FileMode:=$40; (* nur Lesen *)

    if  (Pos('\',dateiname)=0)
    and (Pos('/',dateiname)=0) then
      begin
        voller_name:=ParamStr(0);
        while (voller_name<>'') and not (voller_name[Length(voller_name)] in ['\','/']) do
          Dec(voller_name[0]);

        voller_name:=voller_name+dateiname;
        oeffne;

        if fehler<>0 then
          begin
            voller_name:=FSearch(dateiname,GetEnv('PATH'));
            oeffne;
          end;

        if fehler<>0 then
          begin
            voller_name:=FSearch(dateiname,GetEnv('DPATH'));
            oeffne;
          end;

      end
    else
      begin
        voller_name:=dateiname;
        oeffne;
      end;

    if fehler<>0 then
      begin
        WriteLn('"',dateiname,'"?');
        RunError(fehler);
      end;

    dateilaenge:=FileSize(d);

    (*$IFNDEF VirtualPascal*)
    if dateilaenge>65528 then
      RunError(8);
    (*$ENDIF*)
    GetMem(speicher,dateilaenge);
    BlockRead(d,speicher^,dateilaenge);
    Close(d);

    FileMode:=org_FileMode;

    setze_sprachzeiger(speicher,zeiger_adresse);

  end;

end.

