(* V.K. 04.10.1996 *)
(* 23.10.1996 Kennung *)
(* 01.12.1996 Untersttzung fr ^array[...] *)
(* 12.06.1998 VP20 Frame-, USES NONE, S- *)
(* 1999.11.20 mehr Sprachen, Vorbereitung auf Umgebungsvariable SET LANG=DE_DE *)
(* 2000.01.06 "'" vermieden *)
(* 2001.03.17 Ausgabe in Binrdatei *)
(*&USE32+*)
unit spr2_ein;

interface

(*$I SPR2_DAT*)

procedure sprachtabellenkopf(const abkuerzungen:string);
procedure sprachtabellenkopf_erweitert(const abkuerzungen:string;const nur_ein_feld:boolean);
procedure sprach_eintrag04(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04:string);
procedure sprach_eintrag08(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04,
                                            zk_l05,zk_l06,zk_l07,zk_l08:string);
procedure sprach_eintrag12(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04,
                                            zk_l05,zk_l06,zk_l07,zk_l08,
                                            zk_l09,zk_l10,zk_l11,zk_l12:string);
procedure schreibe_sprach_datei(name_dat,name_pas,objekt_bezeichner,start_bezeichner,typ_bezeichner:string);

implementation

const
  null                          :byte=0;
  max_pascal_zeilenlaenge       =75;

var
  sprachen_vorhanden            :string;
  anzahl_sprachen_vorhanden     :word;
  sprach_elemente               :word;
  zeichenketten_tabelle         :zeichenketten_tabelle_typ;
  eine_variable                 :boolean;
  textz_praefix                 :string;

procedure sprachtabellenkopf(const abkuerzungen:string);
  begin
    sprachtabellenkopf_erweitert(abkuerzungen,false);
  end;

procedure sprachtabellenkopf_erweitert(const abkuerzungen:string;const nur_ein_feld:boolean);
  begin
    sprach_elemente:=0;
    sprachen_vorhanden:=abkuerzungen;
    if (Length(sprachen_vorhanden) mod Length('DE'))<>0 then
      RunError(1);
    anzahl_sprachen_vorhanden:=Length(sprachen_vorhanden) div Length('DE');

    if anzahl_sprachen_vorhanden>High(sprachen_vorhanden_menge) then
      RunError(1);

    eine_variable:=nur_ein_feld;
    if nur_ein_feld then
      textz_praefix:=''
    else
      textz_praefix:='textz_'
  end;

procedure sprach_eintrag_nn(const zk:string;const nn:word);
  begin
    GetMem(zeichenketten_tabelle[sprach_elemente,nn],1+Length(zk));
    zeichenketten_tabelle[sprach_elemente,nn]^:=zk;
  end;

procedure sprach_eintrag_bz(const bezeichner:string);
  begin
    if (Pos(' ',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
    or (Pos('',bezeichner)>0)
      then
        begin
          WriteLn('Fehler:',bezeichner);
          ReadLn;
          Halt;
        end;

    Inc(sprach_elemente);
    if sprach_elemente>High(zeichenketten_tabelle) then
      begin
        WriteLn('zu viele Spracheintrge!');
        Halt(1);
      end;

    sprach_eintrag_nn(bezeichner,00);
  end;



procedure sprach_eintrag04(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04:string);
  begin
    sprach_eintrag_bz(bezeichner);
    sprach_eintrag_nn(zk_l01,01);
    sprach_eintrag_nn(zk_l02,02);
    sprach_eintrag_nn(zk_l03,03);
    sprach_eintrag_nn(zk_l04,04);
  end;

procedure sprach_eintrag08(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04,
                                            zk_l05,zk_l06,zk_l07,zk_l08:string);
  begin
    sprach_eintrag_bz(bezeichner);
    sprach_eintrag_nn(zk_l01,01);
    sprach_eintrag_nn(zk_l02,02);
    sprach_eintrag_nn(zk_l03,03);
    sprach_eintrag_nn(zk_l04,04);
    sprach_eintrag_nn(zk_l05,05);
    sprach_eintrag_nn(zk_l06,06);
    sprach_eintrag_nn(zk_l07,07);
    sprach_eintrag_nn(zk_l08,08);
  end;

procedure sprach_eintrag12(const bezeichner,zk_l01,zk_l02,zk_l03,zk_l04,
                                            zk_l05,zk_l06,zk_l07,zk_l08,
                                            zk_l09,zk_l10,zk_l11,zk_l12:string);
  begin
    sprach_eintrag_bz(bezeichner);
    sprach_eintrag_nn(zk_l01,01);
    sprach_eintrag_nn(zk_l02,02);
    sprach_eintrag_nn(zk_l03,03);
    sprach_eintrag_nn(zk_l04,04);
    sprach_eintrag_nn(zk_l05,05);
    sprach_eintrag_nn(zk_l06,06);
    sprach_eintrag_nn(zk_l07,07);
    sprach_eintrag_nn(zk_l08,08);
    sprach_eintrag_nn(zk_l09,09);
    sprach_eintrag_nn(zk_l10,10);
    sprach_eintrag_nn(zk_l11,11);
    sprach_eintrag_nn(zk_l12,12);
  end;

procedure schreibe_sprach_datei(name_dat,name_pas,objekt_bezeichner,start_bezeichner,typ_bezeichner:string);
  var
    datei_dat                   :text;
    datei_bin                   :file;
    datei_pas                   :text;
    zaehler                     :word;
    sprachzaehler               :sprachen_vorhanden_menge;
    zk_z                        :str_z;
    w1,w2                       :word;
    bin_modus                   :boolean;

  procedure block_asm(var p;anzahl:word);
    var
      zk                        :string;
      zeilenposition            :word;
      l1                        :word;

    procedure asm_ausgabe_neue_zeile;
      begin
        WriteLn(datei_dat);
        zeilenposition:=1;
      end;

    procedure asm_ausgabe_zk(const zk:string);
      var
        z:word;
      begin
        Write(datei_dat,zk);
        Inc(zeilenposition,Length(zk));
      end;

    procedure asm_ausgabe_b(const b,s:byte);
      var
        bs:string;
      begin
        Str(b:s,bs);
        asm_ausgabe_zk(bs);
      end;

    begin
      if bin_modus then
        begin
          BlockWrite(datei_bin,p,anzahl);
          Exit;
        end;

      if anzahl>255 then
        RunError(1);
      Move(p,zk[1],anzahl);
      zk[0]:=Chr(anzahl);


      zeilenposition:=1;

      while zk<>'' do
        begin

          if zeilenposition=1 then
            begin
              asm_ausgabe_zk('    db ');
              if length(zk)<>anzahl then
                asm_ausgabe_zk('    ');
            end;

          w1:=0;
          repeat
            Inc(w1);
            w2:=w1-1;
            if zeilenposition+Length(#39)+w1+Length(#39)>max_pascal_zeilenlaenge then
              break;
            if (zk[w1] in [#0..#31,#39]) or (Length(zk)=anzahl) then
              break;
          until w1>Length(zk);

          if w2>0 then
            begin
              asm_ausgabe_zk(#39+Copy(zk,1,w2)+#39);
              Delete(zk,1,w2);
            end
          else
            begin
              if (Length(zk)=anzahl) then
                asm_ausgabe_b(Ord(zk[1]),3)
              else
                asm_ausgabe_b(Ord(zk[1]),1);
              Delete(zk,1,1);
            end;

          if zk='' then
            asm_ausgabe_neue_zeile
          else
            if zeilenposition+Length(',')>max_pascal_zeilenlaenge then
              asm_ausgabe_neue_zeile
            else
              asm_ausgabe_zk(',');

        end;

      if zeilenposition<>1 then
        asm_ausgabe_neue_zeile
    end;


  begin
    bin_modus:=Pos('.001',name_dat)=0;

    if bin_modus then
      begin
        Assign(datei_bin,name_dat);
        Rewrite(datei_bin,1);
        BlockWrite(datei_bin,spra_kennung,SizeOf(spra_kennung));
        BlockWrite(datei_bin,sprachen_vorhanden,1+Length(sprachen_vorhanden));
        BlockWrite(datei_bin,sprach_elemente,2);
      end
    else
      begin
        Assign(datei_dat,name_dat);
        Rewrite(datei_dat);
        WriteLn(datei_dat,'(* nicht editieren! *)');
        WriteLn(datei_dat,'procedure ',objekt_bezeichner,';assembler;(*&FRAME-*) (*&USES NONE*) (*$S-*)');
        WriteLn(datei_dat,'  asm');
        WriteLn(datei_dat,'    db ',Length(spra_kennung      ):3,',',#39,spra_kennung      ,#39);
        WriteLn(datei_dat,'    db ',Length(sprachen_vorhanden):3,',',#39,sprachen_vorhanden,#39);
        WriteLn(datei_dat,'    dw ',sprach_elemente:3);
      end;

    Assign(datei_pas,name_pas);
    Rewrite(datei_pas);
    WriteLn(datei_pas,'(* nicht editieren! *)');
    WriteLn(datei_pas,'var');
    WriteLn(datei_pas,'  ',start_bezeichner,':longint;'); (* 4 Byte *)

    for zaehler:=1 to sprach_elemente do
      begin

        if (zaehler=1) or (not eine_variable) then
          WriteLn(datei_pas,'  ',textz_praefix,zeichenketten_tabelle[zaehler][00]^,'  :',typ_bezeichner,';');

        for sprachzaehler:=1 to anzahl_sprachen_vorhanden do
          begin

            zk_z:=zeichenketten_tabelle[zaehler,sprachzaehler];

            if zk_z=nil then
              block_asm(null,1)
            else
              begin
                block_asm(zk_z^,1+Length(zk_z^));
                FreeMem(zk_z,1+Length(zk_z^));
              end;

          end;
      end;

    if bin_modus then
      Close(datei_bin)
    else
      begin
        WriteLn(datei_dat,'  end;');
        Close(datei_dat);
      end;

    Close(datei_pas);
  end;

end.
