{$H-,R+,S-,I+}{&Use32+}

program pe_pe;

(*$M 5000000*)
(*$D PE to PE EXE converter * Based on PE2LE by Veit Kannegieser *)

uses
  Dos,                  // FExpand
  WinDos,
  VpSysLow,
  Objects,
  pe2lety,
  VpUtils,
  Strings;

const
  currentversion='v0.9.0412';
  version='2009.04.12';

const
  stub          :pByteArray             =nil;
  stub_laenge   :longint                =0;
  falign        :longint                =4096;

var
  pe_name,stub_name,pe2_name                    :string;
  pe_start,pe_start2                            :longint;
  pe_kopf,pe_kopf2                              :pe_kopf_typ;
  pe_obj_tab_all,pe_obj_tab_all2                :array[0..95] of pe_obj_typ;
  code_puffer                                   :pByteArray;
  current_offset                                :longint;
  vp21_verzeichnis                              :string;

function gleich4(var v1; const v2: array of char): boolean;
  var
    x1: longint absolute v1;
    x2: longint absolute v2;
  begin
    gleich4:= x1 = x2;
  end;

procedure Abbruch(const zk:string);
  begin
    WriteLn(zk);

    (* Write(^G^Z); *)
    Halt(255);
  end;


procedure aufrunden(var l:longint;const r:longint);
  begin
    l:=((l+r-1) div r)*r;
  end;

function aufrundenf(const l:longint;const r:longint):longint;
  begin
    aufrundenf:=((l+r-1) div r)*r;
  end;

procedure weggeben_p(var p:pointer);
  begin
    Dispose(p);
    p:=nil;
  end;

const
  last_length:longint=0;

procedure status(const zk:string);
  var
    z,diff:longint;
  begin
    Write(^m);
    Write(zk);
    if last_length>Length(zk) then
      begin
        diff:=last_length-Length(zk);
        for z:=1 to diff do Write(' ');
        for z:=1 to diff do Write(^h);
      end;
    (*$IFDEF DEBUG*)
    {if last_length<>Length(zk) then
      SysCtrlSleep(1000);}
    (*$ENDIF*)
    last_length:=Length(zk);
    if zk<>'' then Write(' ');
  end;

procedure hilfe;
  begin
    status('');
    WriteLn('usage:');
    WriteLn('  PE2PE <PE-Source> <PE-Target> [/S:STUB] [/A:ALIGN] ..');
    Writeln('    STUB = stub file (dummy or DOS-Extender or DOS-program)');
    Writeln('    ALIGN = file alignment in bits, try numbers from 9 to 24');
    Halt(255);
  end;


function pages(const l:longint):longint;
  begin
    pages:=(l+4096-1) div 4096;
  end;

procedure OpenReadBST(var f:pBufStream;const filename:string);
  begin
    f:=New(pBufStream,Init(filename,stOpenRead,512*1024));
    if f^.Status<>stOK then
      Abbruch('Cannot open '+filename);
  end;

procedure CreateBST(var f:pBufStream;const filename:string);
  begin
    f:=New(pBufStream,Init(filename,stCreate,512*1024));
    if f^.Status<>stOK then
      Abbruch('Error creating '+filename);
  end;

procedure BlockReadBST(f:pBufStream;var buffer;const size:longint);
  begin
    f^.Read(buffer,size);
    if f^.Status<>stOK then
      Abbruch('Source stream read error');
  end;

procedure BlockWriteBST(f:pBufStream;var buffer;const size:longint);
  begin
    f^.Write(buffer,size);
    if f^.Status<>stOK then
      Abbruch('Target stream write error');
  end;

procedure SeekBST(f:pBufStream;l:longint);
  begin
    f^.Seek(l);
    if f^.Status<>stOK then
      Abbruch('Stream seek error');
  end;

procedure CloseBST(var f:pBufStream);
  begin
    f^.Done;
    f:=nil;
  end;

function FileSizeBST(f:pBufStream):longint;
  begin
    Result:=f^.GetSize;
    if f^.Status<>stOK then
      Abbruch('Stream FileSize error');
  end;

(*************************************************************************)
procedure lies_stub(const dateiname:string);
  var
    ds                  :pBufStream;
    puffer              :array[0..$3f] of char;
    exe_kopf            :exe_kopf_typ;
    code_laenge         :longint;
    position            :longint;
  begin

    status('Processing stub file...');
    if dateiname='' then
      begin
        stub_laenge:=0;
        Exit;
      end;

    OpenReadBST(ds,dateiname);
    BlockReadBST(ds,exe_kopf,2);

    (* EXE? *)
    if (exe_kopf.sig='MZ')
    or (exe_kopf.sig='ZM')
     then
      begin
        SeekBST(ds,0);
        BlockReadBST(ds,exe_kopf,SizeOf(exe_kopf));

        code_laenge:=exe_kopf.page512*512;
        if exe_kopf.mod512>0 then
          Inc(code_laenge,exe_kopf.mod512-512);
        Dec(code_laenge,longint(exe_kopf.kopfgroesse)*16);

        stub_laenge:=$40+longint(exe_kopf.relo_anz)*4;
        aufrunden(stub_laenge,16);
        Inc(stub_laenge,code_laenge);
        aufrunden(stub_laenge,16);

        GetMem(stub,stub_laenge);
        FillChar(stub^,stub_laenge,0);

        exe_kopf.mod512:=stub_laenge mod 512;
        exe_kopf.page512:=stub_laenge div 512;
        if exe_kopf.mod512>0 then
          Inc(exe_kopf.page512);

        SeekBST(ds,exe_kopf.relo_ofs);
        position:=$40;
        exe_kopf.relo_ofs:=position;
        BlockReadBST(ds,stub^[position],longint(exe_kopf.relo_anz)*4);
        Inc(position,longint(exe_kopf.relo_anz)*4);
        aufrunden(position,16);

        SeekBST(ds,longint(exe_kopf.kopfgroesse)*16);
        exe_kopf.kopfgroesse:=position div 16;
        BlockReadBST(ds,stub^[position],code_laenge);
        exe_kopf.kopfgroesse:=($40+longint(exe_kopf.relo_anz)*4+15) div 16;

        with exe_kopf do
          begin
            pruefsumme:=0;
            ov_nummer :=0;
            FillChar(rest,SizeOf(rest),0);
            x_exe_zeiger:=stub_laenge;
          end;
        Move(exe_kopf,stub^[0],$40);
        CloseBST(ds);
      end
    else
      (* kein Stub *)
      if  (   (exe_kopf.sig='NE')
           or (exe_kopf.sig='LE')
           or (exe_kopf.sig='LX')
           or (exe_kopf.sig='PE'))
      (* auch andere 'sig' pruefen? *)
      and (MemW[Ofs(exe_kopf)+2]=0)
       then
        begin
          CloseBST(ds);
          Abbruch('Not a good stub file');
        end
    else
      (* COM *)
      begin
        if FileSizeBST(ds)>64000 then
          begin
            CloseBST(ds);
            Abbruch('Stub is to big to be an COM file (64K)!');
          end;

        stub_laenge:=$40+FileSizeBST(ds);
        aufrunden(stub_laenge,16);
        GetMem(stub,stub_laenge);
        FillChar(stub^,stub_laenge,0);

        (* COM -> EXE *)
        with exe_kopf_typ(stub^[0]) do
          begin
            sig:='MZ';
            mod512:=FileSizeBST(ds) mod 512;
            page512:=FileSizeBST(ds) div 512;
            if mod512<>0 then Inc(page512);
            relo_anz:=0;
            kopfgroesse:=SizeOf(exe_kopf_typ) div 16;
            min:=$1000-((FileSizeBST(ds)+15) div 16);
            max:=$ffff;
            _ss:=$fff0;
            _sp:=$fffe;
            pruefsumme:=0;
            _ip:=$0100;
            _cs:=$fff0;
            relo_ofs:=0;
            ov_nummer:=0;
            FillChar(rest,SizeOf(rest),0);
            x_exe_zeiger:=stub_laenge;
          end;

        SeekBST(ds,0);
        BlockReadBST(ds,stub^[$40],FileSizeBST(ds));
        CloseBST(ds);
      end;


  end;


(*************************************************************************)
procedure anfang;
  var
    tmp                 :string;
    z1,z2               :longint;
    sw                  :char;
    n,e                 :string;
    searchpath          :PChar;
    foundfile           :array[0..260] of char;
    code                :integer;
  begin

    WriteLn('PE2PE '+currentversion+' * Based on PE2LE by Veit Kannegieser * '+version);
    status('Checking parameters...');

    // "D:\VP20" ausrechnen
    vp21_verzeichnis:=GetEnv('VPBASE');
    if vp21_verzeichnis='' then
      begin
        FSplit(ParamStr(0),vp21_verzeichnis,n,e);
        z1:=Length(vp21_verzeichnis)-Length('\BIN.???\'); (* or \OUT.???\ *)
        if (z1>0)
        and (       vp21_verzeichnis[z1+1] ='\')
        and (UpCase(vp21_verzeichnis[z1+2]) in ['B','O'])
        and (UpCase(vp21_verzeichnis[z1+3]) in ['I','U'])
        and (UpCase(vp21_verzeichnis[z1+4]) in ['N','T'])
        and (       vp21_verzeichnis[z1+5] ='.')
        and (       vp21_verzeichnis[z1+9] ='\') then
          SetLength(vp21_verzeichnis,z1);
      end;

    stub_name:='';

    z1:=0;
    z2:=0;
    repeat
      Inc(z1);
      if z1>ParamCount then Break;

      if z2>2 then hilfe;

      tmp:=ParamStr(z1);


      if tmp='' then
        Continue;

      if tmp[1] in ['/','-'] then
        begin
          if Length(tmp)<Length('/S') then hilfe;
          sw:=UpCase(tmp[2]);
          Delete(tmp,1,Length('/S'));
          if Copy(tmp,1,1)=':' then
            Delete(tmp,1,Length(':'));
          if Copy(tmp,1,1)='"' then
            tmp:=Copy(tmp,2,Length(tmp)-2);
          case sw of
            'A':
              begin
                Val(tmp,falign,code);
                if code<>0 then
                  Abbruch('Argument must be a number!');
                if falign<9 then
                  falign:=9;
                if falign>24 then
                  falign:=24;
                falign:=longint(1) shl falign;
              end;
            'S':stub_name   :=tmp;
            '*':
              begin
                Inc(z2);
                pe2_name:=Copy(pe_name,1,Length(pe_name)-Length('.EXE'))+'.COM';
              end;

          else
            hilfe;
          end;
        end
      else
        begin
          Inc(z2);
          case z2 of
           1:pe_name:=tmp;
           2:pe2_name:=tmp;
          end;
        end;
    until false;

    if (Pos('/',stub_name)=0) and (Pos('\',stub_name)=0) then
      begin (* stub_name non-empty, but without path *)

        GetMem(searchpath,Length(vp21_verzeichnis)+Length('\BIN.D32;')
                                +StrLen(GetEnvVar('PATH'))
{$IFDEF OS2}
                                +Length(';')+StrLen(GetEnvVar('DPATH'))
{$ENDIF}
                                +1);
        StrPCopy(searchpath,vp21_verzeichnis);
        StrCat(searchpath,'\BIN.D32;');
        StrCat(searchpath,GetEnvVar('PATH'));
{$IFDEF OS2}
        StrCat(searchpath,';');
        StrCat(searchpath,GetEnvVar('DPATH'));
{$ENDIF}

        FillChar(foundfile,SizeOf(foundfile),0);
        FileSearch(foundfile,@(stub_name+#0)[1],searchpath);
        if StrLen(foundfile)<>0 then
          stub_name:=StrPas(foundfile);
      end;

    if z2<>2 then hilfe;
  end;

procedure konvert;

  var
    datei,
    datei2              :pBufStream;
    puffer              :array[0..$3f] of char;
    p1                  :longint;
    i                   :SmallWord;
    new_size, fill_size :longint;

  procedure lies(var p:pByteArray;var obj:pe_obj_typ);
    begin
      GetMem(p,obj.physical_size);
      SeekBST(datei,obj.physical_offset);
      BlockReadBST(datei,p^,obj.physical_size);
    end;

  begin
    lies_stub(stub_name);

    status('Reading source executable...');
    OpenReadBST(datei,pe_name);

    pe_start:=0;
    repeat
      BlockReadBST(datei,puffer,SizeOf(puffer));

      if gleich4(puffer, 'PE'#0#0) then break;
      if gleich4(puffer, 'PL'#0#0) then break; // VPT: Pharlap signature
      if gleich4(puffer, 'PX'#0#0) then break; // VPT: HX and DOS4G signature
      if gleich4(puffer, 'BPE'#0)  then break; // VPT: Unilink/Doswin32 signature

      if ((puffer[0]='M') and (puffer[1]='Z'))
      or ((puffer[0]='Z') and (puffer[1]='M'))
       then
        begin
          pe_start:=pLongint(@puffer[$3c])^;
          SeekBST(datei,pe_start);
          Continue;
        end;

      if gleich4(puffer, 'LX'#0#0) then
        Abbruch('Source is LX-executable!');

      if gleich4(puffer, 'LE'#0#0) then
        Abbruch('Source is LE-executable!');

      Abbruch('Invalid source executable format!');

    until false;

    SeekBST(datei,pe_start);
    BlockReadBST(datei,pe_kopf,SizeOf(pe_kopf));

    if pe_kopf.magic = $020B then
      Abbruch('64 bit executables are not supported!');
    if pe_kopf.magic = $0107 then
      Abbruch('ROM images are not supported!');
    if pe_kopf.magic<> $010B then
      Abbruch('Unknown type of executable image!');

    pe_kopf2 := pe_kopf;
    pe_kopf2.file_align := falign;
    pe_kopf2.nthdrsize := $E0;   (* Standard size *)
    pe_kopf2.file_checksum := 0; (* TO DO: Checksum recalculation *)
    pe_kopf2.interestings := 16;
    pe_kopf2.f_symptr := 0;
    pe_kopf2.f_nsyms := 0;
    pe_kopf2.security_table := 0; (* Certificates are discarded *)
    pe_kopf2.security_size := 0;
    pe_kopf2.bound_import_table := 0;
    pe_kopf2.bound_import_size := 0;
    pe_start2 := stub_laenge;

    (* obj-Tabelle laden *)

    if pe_kopf.num_obj > 96 then
      Abbruch('Schade!');

    SeekBST(datei,pe_start+pe_kopf.nthdrsize+$18);
    for i:=0 to pe_kopf.num_obj - 1 do
      BlockReadBST(datei,pe_obj_tab_all[i],SizeOf(pe_obj_typ));

    FillChar(pe_obj_tab_all2, sizeof(pe_obj_tab_all2), 0);

    pe_kopf2.header_size := pe_start2
                      + SizeOf(pe_kopf2)
                      + pe_kopf.num_obj * SizeOf(pe_obj_typ);

    current_offset := pe_kopf2.header_size;

    for i:=0 to pe_kopf.num_obj - 1 do
      begin
        pe_obj_tab_all2[i].name                 := pe_obj_tab_all[i].name;
        pe_obj_tab_all2[i].virtual_size         := pe_obj_tab_all[i].virtual_size;
        pe_obj_tab_all2[i].rva                  := pe_obj_tab_all[i].rva;
        pe_obj_tab_all2[i].physical_size        := pe_obj_tab_all[i].physical_size;
        if pe_obj_tab_all[i].physical_offset > 0 then
          begin
            pe_obj_tab_all2[i].physical_offset      := aufrundenf(current_offset, falign);
            current_offset := pe_obj_tab_all2[i].physical_offset + pe_obj_tab_all2[i].physical_size;
          end;
        pe_obj_tab_all2[i].obj_flags            := pe_obj_tab_all[i].obj_flags;
      end;
    status('Writing target...');

    CreateBST(datei2,pe2_name);
    if stub_laenge>0 then
      BlockWriteBST(datei2,stub^,stub_laenge);
    BlockWriteBST(datei2,pe_kopf2,SizeOf(pe_kopf2));
    for i:=0 to pe_kopf.num_obj - 1 do
      BlockWriteBST(datei2,pe_obj_tab_all2[i],SizeOf(pe_obj_typ));

    current_offset := pe_kopf2.header_size;
    for i:=0 to pe_kopf.num_obj - 1 do
      if pe_obj_tab_all2[i].physical_offset > 0 then
        begin
          fill_size := pe_obj_tab_all2[i].physical_offset - current_offset;
          if fill_size >0 then
            begin
              GetMem(code_puffer,fill_size);
              FillChar(code_puffer^, fill_size, 0);
              SeekBST(datei2, current_offset);
              BlockWriteBST(datei2, code_puffer^, fill_size);
              FreeMem(code_puffer,fill_size);
            end;
          GetMem(code_puffer,pe_obj_tab_all2[i].physical_size);
          SeekBST(datei, pe_obj_tab_all[i].physical_offset);
          BlockReadBST(datei,code_puffer^, pe_obj_tab_all[i].physical_size);
          fill_size := pe_obj_tab_all2[i].physical_size - pe_obj_tab_all[i].physical_size;
          if fill_size >0 then
            FillChar(code_puffer^[pe_obj_tab_all[i].physical_size], fill_size, 0);
          SeekBST(datei2, pe_obj_tab_all2[i].physical_offset);
          BlockWriteBST(datei2,code_puffer^, pe_obj_tab_all2[i].physical_size);
          FreeMem(code_puffer,pe_obj_tab_all2[i].physical_size);
          current_offset := pe_obj_tab_all2[i].physical_offset
                          + pe_obj_tab_all2[i].physical_size;
        end;

    CloseBST(datei2);
    CloseBST(datei);

  end;

begin
  (*$IFDEF LINUX*)
  FileSystem := fsDos;
  (*$ENDIF*)

  anfang;
  konvert;
  Write(^Z);
end.

