(* Based on Veit Kannegieser's ER_ZTAB           *)
(* ztab generator                                *)
(* binobj32 ztab ztab32.obj ztab_obj             *)
(* VPT: 2009.01.04 Windows version               *)
(* TO DO: Portable version for Linux and DOS     *)

(*$Use32+*)
{ $Define Debug}
program er_ztab;

uses
  Dos,
  ztab,
  unidef,
  Windows,
  VpUtils;

type
  size_t                =word;

var
  cp                    :word;

procedure probiere(cp:word);
  var
    name8               :string;
    z                   :char;
    tabelle8            :zeichensatz8_zu_uc_tabelle;
    tabelleuc           :uc_zu_zeichensatz8_tabelle;

    temp                :pUniCharArray;
    rc                  :integer;
    pc                  :array[0..1] of char;
    inbuf               :pchar;
    inbytesleft         :size_t;
    ucsbuf              :pUniCharArray;
    UniCharsleft        :size_t;
    nonidentical        :size_t;

    d                   :file;
    gefunden            :boolean;

  begin
    if IsValidCodePage(cp) then
      begin
        Str(cp, name8);
        Write(name8,' ');

        temp:=NewUniCharArray(1);
        for z:=Low(char) to High(char) do
          begin
            pc[0]:=z;
            pc[1]:=#0;
            inbuf:=@pc;
            inbytesleft:=1;
            ucsbuf:=temp;
            UniCharsleft:=1;

            rc:=
            MultiByteToWideChar(cp, 0,
              inbuf, inbytesleft, LPWSTR(ucsbuf), UniCharsleft);

            case rc of
              1:
                tabelle8[z]:=temp^[0];
            else
              (* 7-bit..*)
                if z<#$80 then
                  tabelle8[z]:=Ord(z)
                else
                  tabelle8[z]:=$ffff;
            end;
          end;

        (* Ich nehme nur Zeichenstze mit '?' *)
        gefunden:=false;
        for z:=Low(char) to High(char) do
          if tabelle8[z]=Ord('?') then
            begin
              gefunden:=true;
              Break;
            end;

        FreeUniCharArray(temp^);

        erzeuge_uc_zu_zeichensatz8_tabelle(tabelle8,tabelleuc);

        if gefunden then
          merke_paket(cp,tabelleuc)
        else
          begin
            WriteLn('?');
            //ReadLn;
          end;

{$IfDef Debug}
        Assign(d,GetEnv('TMP')+'\'+name8+'.8');
        Rewrite(d,1);
        BlockWrite(d,tabelle8,SizeOf(tabelle8));
        Close(d);

        Assign(d,GetEnv('TMP')+'\'+name8+'.UC');
        ReWrite(d,1);
        with tabelleuc do
          BlockWrite(d,tabelleuc,SizeOf(tabelleuc)-SizeOf(folgen)+anzahl_folgen*SizeOf(folgen[1]));
        Close(d);
{$EndIf}

      end;
  end;

begin

for cp:=1 to 920 do
    begin
      Write(cp:5,^h^h^h^h^h);
      probiere(cp);
    end;
(* VPT: skip DBCS in 921..979 *)
for cp:=980 to 10000 do
    begin
      if cp = 1361 then
        continue;
      Write(cp:5,^h^h^h^h^h);
      probiere(cp);
    end;
(* VPT: skip DBCS in 10001..10003 *)
for cp:=10004 to 19999 do
    begin
      if cp = 10008 then
        continue;
      Write(cp:5,^h^h^h^h^h);
      probiere(cp);
    end;
(* VPT: skip DBCS in 20000..20099 *)
for cp:=20100 to 20920 do
    begin
      if cp = 20261 then
        continue;
      Write(cp:5,^h^h^h^h^h);
      probiere(cp);
    end;
(* VPT: skip DBCS in 20921..20979 *)
for cp:=20980 to 64999 do
    begin
      Write(cp:5,^h^h^h^h^h);
      probiere(cp);
    end;
(* VPT: 65000 = UTF-7; 65001 = UTF-8 *)
WriteLn('     ');

  speichere_pakete;
end.

